/*=================================================================
	File created by Yohann NICOLAS.
	Add support 1.13d by L'Autour.
	Add support 1.14d by haxifix.

	Interface stats page functions

=================================================================*/

#include "interface_Stash.h"
#include "updateServer.h"
#include "infinityStash.h"
#include "plugYFiles.h"		// Install_PlugYImagesFiles()
#include "common.h"
#include <stdio.h>
#include <ctime>      // Include ctime for srand and rand functions
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <cstdlib>
#include <Windows.h>

static struct
{
	union{
		DWORD all;
		struct{
			DWORD previous:1;
			DWORD next:1;
			DWORD toggleToSharedStash:1;
			DWORD previousIndex:1;
			DWORD nextIndex:1;
			DWORD putGold:1;
			DWORD takeGold:1;
			DWORD stashName:1;
		};
	};
} isDownBtn;

bool displaySharedSetItemNameInGreen = true;
int posXPreviousBtn = -1;
int posYPreviousBtn = -1;
int posWPreviousBtn = 32;
int posHPreviousBtn = 32;
int posXNextBtn = -1;
int posYNextBtn = -1;
int posWNextBtn = 32;
int posHNextBtn = 32;
int posXSharedBtn = -1;
int posYSharedBtn = -1;
int posWSharedBtn = 32;
int posHSharedBtn = 32;
int posXPreviousIndexBtn = -1;
int posYPreviousIndexBtn = -1;
int posWPreviousIndexBtn = 32;
int posHPreviousIndexBtn = 32;
int posXNextIndexBtn = -1;
int posYNextIndexBtn = -1;
int posWNextIndexBtn = 32;
int posHNextIndexBtn = 32;
int posXPutGoldBtn = -1;
int posYPutGoldBtn = -1;
int posWPutGoldBtn = 32;
int posHPutGoldBtn = 32;
int posXTakeGoldBtn = -1;
int posYTakeGoldBtn = -1;
int posWTakeGoldBtn = 32;
int posHTakeGoldBtn = 32;
int posXStashNameField = -1;
int posYStashNameField = -1;
int posWStashNameField = 175;
int posHStashNameField = 20;
int posXStashGoldField = -1;
int posYStashGoldField = -1;
int posWStashGoldField = 152;
int posHStashGoldField = 18;

#include <chrono>



DWORD PersonalNormalPageColor = WHITE;
DWORD PersonalIndexPageColor = DARK_GREEN;
DWORD PersonalMainIndexPageColor = YELLOW;
DWORD SharedNormalPageColor = GOLD;
DWORD SharedIndexPageColor = ORANGE;
DWORD SharedMainIndexPageColor = RED;


DWORD	getXPreviousBtn()		{return RX(posXPreviousBtn<0? D2GetResolution()?0x80:0xAF : posXPreviousBtn);}
DWORD	getYPreviousBtn()		{return RY(posYPreviousBtn<0 ? 0x40 : posYPreviousBtn);}
DWORD	getXNextBtn()			{return RX(posXNextBtn<0 ? D2GetResolution()?0xA0:0xCF :posXNextBtn);}//?169:SEL_X(0x63, 0x63, 0xCF, 0xA0));}
DWORD	getYNextBtn()			{return RY(posYNextBtn<0 ? 0x40 : posYNextBtn);}
DWORD	getXSharedBtn()			{return RX(posXSharedBtn<0 ? D2GetResolution()?0x10:0x6F :posXSharedBtn);}//17:SEL_X(0xE3, 0xE3, 0x6F, 0x10));}//0xD8
DWORD	getYSharedBtn()			{return RY(posYSharedBtn<0 ? 0x40 : posYSharedBtn);}
DWORD	getXPreviousIndexBtn()	{return RX(posXPreviousIndexBtn<0 ?  D2GetResolution()?0x60:0x8F :posXPreviousIndexBtn);}//73:SEL_X(0x18, 0x60, 0x8F, 0x60));}
DWORD	getYPreviousIndexBtn()	{return RY(posYPreviousIndexBtn<0 ? 0x40 : posYPreviousIndexBtn);}
DWORD	getXNextIndexBtn()		{return RX(posXNextIndexBtn<0? D2GetResolution()?0xC0:0xEF : posXNextIndexBtn);}//217:SEL_X(0x128, 0xC0, 0xEF, 0xC0));}
DWORD	getYNextIndexBtn()		{return RY(posYNextIndexBtn<0 ? 0x40 : posYNextIndexBtn);}
DWORD	getXPutGoldBtn()		{return RX(posXPutGoldBtn<0? 0x1C : posXPutGoldBtn);}
DWORD	getYPutGoldBtn()		{return RY(posYPutGoldBtn<0 ? 0x1A8 : posYPutGoldBtn);}
DWORD	getXTakeGoldBtn()		{return RX(posXTakeGoldBtn<0? 0x105 : posXTakeGoldBtn);}
DWORD	getYTakeGoldBtn()		{return RY(posYTakeGoldBtn<0 ? 0x1A8 : posYTakeGoldBtn);}
DWORD	getXStashNameField()	{return RX(posXStashNameField<0 ? 0x4A : posXStashNameField);}
DWORD	getYStashNameField()	{return RY(posYStashNameField<0 ? 0x19A : posYStashNameField);}
DWORD	getXStashGoldField()	{return RX(posXStashGoldField<0 ? 0x61 : posXStashGoldField);}
DWORD	getYStashGoldField()	{return RY(posYStashGoldField<0 ? 0x1B6 : posYStashGoldField);}

//closeBtn x: D2C=0x113 LOD=0x110(0->0x28)		y: D2C=0x41 LOD=0x40 (-0x23 -> 5)


#define isOnButtonNextStash(x,y) isOnRect(x, y, getXNextBtn(), getYNextBtn(), posWNextBtn, posHNextBtn)
#define isOnButtonPreviousStash(x,y) isOnRect(x, y, getXPreviousBtn(), getYPreviousBtn(), posWPreviousBtn, posHPreviousBtn)
#define isOnButtonToggleSharedStash(x,y) isOnRect(x, y, getXSharedBtn(), getYSharedBtn(), posWSharedBtn, posHSharedBtn)
#define isOnButtonNextIndexStash(x,y) isOnRect(x, y, getXNextIndexBtn(), getYNextIndexBtn(), posWNextIndexBtn, posHNextIndexBtn)
#define isOnButtonPreviousIndexStash(x,y) isOnRect(x, y, getXPreviousIndexBtn(), getYPreviousIndexBtn(), posWPreviousIndexBtn, posHPreviousIndexBtn)
#define isOnButtonPutGold(x,y) isOnRect(x, y, getXPutGoldBtn(), getYPutGoldBtn(), posWPutGoldBtn, posHPutGoldBtn)
#define isOnButtonTakeGold(x,y) isOnRect(x, y, getXTakeGoldBtn(), getYTakeGoldBtn(), posWTakeGoldBtn, posHTakeGoldBtn)
#define isOnStashNameField(x,y) isOnRect(x, y, getXStashNameField(), getYStashNameField(), posWStashNameField, posHStashNameField)
#define isOnStashGoldField(x,y) isOnRect(x, y, getXStashGoldField(), getYStashGoldField(), posWStashGoldField, posHStashGoldField)

void UpdateStashPosition()
{
	//static int isInstalled = false;
	//if (isInstalled) return;

	InventoryBIN* inventory = D2GetInventoryBIN();
	if (inventory->gridY == 15)
	{
		posXPreviousBtn = 127;
		posYPreviousBtn = 500;
		posXNextBtn = 159;
		posYNextBtn = 500;
		posXSharedBtn = 28;
		posYSharedBtn = 21;
		posXPreviousIndexBtn = 95;
		posYPreviousIndexBtn = 500;
		posXNextIndexBtn = 191;
		posYNextIndexBtn = 500;
		posXPutGoldBtn = 28;
		posYPutGoldBtn = 500;
		posXTakeGoldBtn = 259;
		posYTakeGoldBtn = 500;
		//posXStashNameField = -1;
		posYStashNameField = 16;
		//posXStashGoldField = -1;
		posYStashGoldField = 36;
	}
}

void* STDCALL printBtns()
{
	if (onRealm || !D2isLODGame()) return D2LoadBuySelBtn();

	Unit* ptChar = D2GetClientPlayer();

	sDrawImageInfo data;
	ZeroMemory(&data,sizeof(data));
	setImage(&data, stashBtnsImages);

	setFrame(&data, 0 + isDownBtn.previous);
	D2PrintImage(&data, getXPreviousBtn(), getYPreviousBtn(), -1, 5, 0);

	setFrame(&data, 2 + isDownBtn.next);
	D2PrintImage(&data, getXNextBtn(), getYNextBtn(), -1, 5, 0);

	if (active_sharedStash)
	{
		setFrame(&data, 4 + isDownBtn.toggleToSharedStash + (PCPY->showSharedStash?2:0) );
		D2PrintImage(&data, getXSharedBtn(), getYSharedBtn(), -1, 5, 0);
	}

	setFrame(&data, 8 + isDownBtn.previousIndex);
	D2PrintImage(&data, getXPreviousIndexBtn(), getYPreviousIndexBtn(), -1, 5, 0);

	setFrame(&data, 10 + isDownBtn.nextIndex);
	D2PrintImage(&data, getXNextIndexBtn(), getYNextIndexBtn(), -1, 5, 0);

	if (active_sharedGold)
	{
		setImage(&data, sharedGoldBtnsImages);
		setFrame(&data, 0 + isDownBtn.putGold);
		D2PrintImage(&data, getXPutGoldBtn(), getYPutGoldBtn(), -1, 5, 0);

		setFrame(&data, 2 + isDownBtn.takeGold);
		D2PrintImage(&data, getXTakeGoldBtn(), getYTakeGoldBtn(), -1, 5, 0);
	}


	LPWSTR lpText;
	DWORD mx = D2GetMouseX();
	DWORD my = D2GetMouseY();

	D2SetFont(1);

	if (isOnButtonPreviousStash(mx,my)) {
		lpText = getLocalString(STR_STASH_PREVIOUS_PAGE);
		D2PrintPopup(lpText, getXPreviousBtn()+posWPreviousBtn/2, getYPreviousBtn()-posHPreviousBtn, WHITE, 1);

	} else if (isOnButtonNextStash(mx,my)) {
		lpText = getLocalString(STR_STASH_NEXT_PAGE);
		D2PrintPopup(lpText, getXNextBtn()+posWNextBtn/2, getYNextBtn()-posHNextBtn, WHITE, 1);

	} else if (isOnButtonToggleSharedStash(mx,my)) {
		if (active_sharedStash) {
			lpText = getLocalString(PCPY->showSharedStash ? STR_TOGGLE_TO_PERSONAL : STR_TOGGLE_TO_SHARED);
			D2PrintPopup(lpText, getXSharedBtn()+posWSharedBtn/2, getYSharedBtn()-posHSharedBtn, WHITE, 1);
		} else if (active_SharedStashInMultiPlayer == 1) {
			lpText = getLocalString(STR_TOGGLE_MULTI_DISABLED);
			D2PrintPopup(lpText, getXPreviousIndexBtn()+posWPreviousIndexBtn/2, getYPreviousIndexBtn()-posHPreviousIndexBtn, WHITE, 1);
		}

	} else if (isOnButtonPreviousIndexStash(mx,my)) {
		lpText = getLocalString(STR_STASH_PREVIOUS_INDEX);
		D2PrintPopup(lpText, getXPreviousIndexBtn()+posWPreviousIndexBtn/2, getYPreviousIndexBtn()-posHPreviousIndexBtn, WHITE, 1);

	} else if (isOnButtonNextIndexStash(mx,my))	{
		lpText = getLocalString(STR_STASH_NEXT_INDEX);
		D2PrintPopup(lpText, getXNextIndexBtn()+posWNextIndexBtn/2, getYNextIndexBtn()-posHNextIndexBtn, WHITE, 1);

	} else if (active_sharedGold && isOnButtonPutGold(mx,my))	{
		lpText = getLocalString(STR_PUT_GOLD);
		D2PrintPopup(lpText, getXPutGoldBtn()+posWPutGoldBtn/2, getYPutGoldBtn()-posHPutGoldBtn, WHITE, 1);

	} else if (active_sharedGold && isOnButtonTakeGold(mx,my))	{
		lpText = getLocalString(STR_TAKE_GOLD);
		D2PrintPopup(lpText, getXTakeGoldBtn()+posWTakeGoldBtn/2, getYTakeGoldBtn()-posHTakeGoldBtn, WHITE, 1);
	}

	return D2LoadBuySelBtn();
}


DWORD STDCALL manageBtnDown(sWinMessage* msg)
{
	if (onRealm || !D2isLODGame()) return 0;

	if (isOnButtonPreviousStash(msg->x,msg->y))
		isDownBtn.previous = 1;
	else if (isOnButtonNextStash(msg->x,msg->y))
		isDownBtn.next = 1;
	else if (active_sharedStash && isOnButtonToggleSharedStash(msg->x,msg->y))
		isDownBtn.toggleToSharedStash = 1;
	else if (isOnButtonPreviousIndexStash(msg->x,msg->y))
		isDownBtn.previousIndex = 1;
	else if (isOnButtonNextIndexStash(msg->x,msg->y))
		isDownBtn.nextIndex = 1;
	else if (active_sharedGold && isOnButtonPutGold(msg->x,msg->y))
		isDownBtn.putGold = 1;
	else if (active_sharedGold && isOnButtonTakeGold(msg->x,msg->y))
		isDownBtn.takeGold = 1;
	else if (isOnStashNameField(msg->x,msg->y))
		isDownBtn.stashName = 1;
	else return 0;

	D2PlaySound(4,0,0,0,0);
	freeMessage(msg);
	return 1;
}


DWORD STDCALL manageBtnUp(sWinMessage* msg)
{
	if (onRealm || !D2isLODGame()) return 0;

	Unit* ptChar = D2GetClientPlayer();

	if (isOnButtonPreviousStash(msg->x,msg->y)) {
		log_msg("push up left button previous\n");
		if (isDownBtn.previous)
			if (GetKeyState(VK_SHIFT)<0)
				updateServer(US_SELECT_PREVIOUS2);
			else
				updateServer(US_SELECT_PREVIOUS);

	} else if (isOnButtonNextStash(msg->x,msg->y)) {
		log_msg("push up left button next\n");
		if (isDownBtn.next)
			if (GetKeyState(VK_SHIFT)<0)
				updateServer(US_SELECT_NEXT2);
			else
				updateServer(US_SELECT_NEXT);

	} else if (active_sharedStash && isOnButtonToggleSharedStash(msg->x,msg->y)) {
		log_msg("push up left button shared\n");
		if (isDownBtn.toggleToSharedStash)
			if (PCPY->showSharedStash)
				updateServer(US_SELECT_SELF);
			else
				updateServer(US_SELECT_SHARED);

	} else if (isOnButtonPreviousIndexStash(msg->x,msg->y)) {
		log_msg("select left button previous index\n");
		if (isDownBtn.previousIndex)
			if (GetKeyState(VK_SHIFT)<0)
				updateServer(US_SELECT_PREVIOUS_INDEX2);
			else
				updateServer(US_SELECT_PREVIOUS_INDEX);

	} else if (isOnButtonNextIndexStash(msg->x,msg->y)) {
		log_msg("push up left button next index\n");
		if (isDownBtn.nextIndex)
			if (GetKeyState(VK_SHIFT)<0)
				updateServer(US_SELECT_NEXT_INDEX2);
			else
				updateServer(US_SELECT_NEXT_INDEX);

	} else if (active_sharedGold && isOnButtonPutGold(msg->x,msg->y)) {
		log_msg("push up left put gold\n");
		if (isDownBtn.putGold)
			updateServer(US_PUTGOLD);

	} else if (active_sharedGold && isOnButtonTakeGold(msg->x,msg->y)) {
		log_msg("push up left take gold\n");
		if (isDownBtn.takeGold)
			updateServer(US_TAKEGOLD);

	} else if (isOnStashNameField(msg->x,msg->y)) {
		log_msg("push up left Stash Name\n");
		if (isDownBtn.stashName && PCPY->currentStash)
		{
			if (GetKeyState(VK_SHIFT)<0)
			{
				WCHAR text[21];
				getCurrentStashName(text, 21, ptChar);
				D2TogglePage(5,0,0);// Open command window
				_snwprintf(ptInputCommand, 25, L"/rp %s", text);
				InputCommandLen = wcslen(ptInputCommand);
			}
			else if (PCPY->currentStash->isMainIndex)
				updateServer(US_RESET_INDEX);
			else if (PCPY->currentStash->isIndex)
				updateServer(US_SET_MAIN_INDEX);
			else
				updateServer(US_SET_INDEX);
		}

	} else return 0;

	return 1;
}

int frame = 0;
long nEndTime = 0;
int nTip = 0;
long DURATION = 15000;
std::vector<std::wstring> diablo2Tips = {
		L"Consume spirits like potions to increase Spirits Quaffed stat in character stat sheet page.",
		L"Cube Souls with Energy Sphere to capture Soul Energy and use it to create powerful items. Recipes will come later.",
		L"Collect Demon souls from demons and regular souls from monsters; Demon souls morph you into the demon whose soul you have.",
		L"Spirits can be consumed like potions or put on as rings to add to Souls Consumed count.",
		L"Cube underused magic, rare, set, unique items with Energy Sphere to collect their magic energy for creating new items.",
		L"Cube white items with Energy Sphere to break down into simple item parts for creating base item types with smithing hammers.",
		L"Use Rare Shard, Set Stone, or Unique Particle with smithing hammers and Energy Sphere to create rare, set, unique items.",
		L"Acquire smithing hammers to create base item types, each requiring X number of collected item parts.",
		L"Capture Talisman of Corruption and cube to corrupt items for new magical properties; a gamble with potential rewards.",
		L"Use Experience Book for extra experience, Infinite Mana Elixir for massive mana regeneration, and Regeneration Elixir for life regeneration.",
		L"Use Elixirs to permanently boost stats like Strength, Dexterity, Health, Stamina, Mana, and resistances.",
		L"Equip Sling Stone for increased throwing potion damage, various elemental stones for resistance boosts, and Mastery Stones for skill damage boosts.",
		L"Use Portable Shrines for temporary buffs like increased defense, damage, experience gained, mana regeneration, and skill levels.",
		L"In Ironman, gold is nonexistent, town portals are disabled; rely on items, waypoints, and strategic gameplay to progress.",
		L"Inventory management is critical; use items conservatively and intelligently switch gear based on monster types and situations.",
		L"Hybrid character builds and creative weapon choices are encouraged in Ironman; experiment and adapt strategies accordingly.",
		L"Protect hirelings actively as they are essential allies; they can be hired for 0 gold but lose items if they die.",
		L"Coordinate with teammates in MultiPlayer; teamwork, resource sharing, and strategy are key to success in Ironman.",
		L"In Hardcore Ironman, caution and careful planning are crucial; falling back, potion management, and adaptability are essential for survival.",
		L"Utilize waypoints for inter-level travel in Ironman; waypoints become crucial for navigating the game world.",
		L"Always have backup gear in your backpack in Ironman; switch out gear intelligently based on monster types and challenges.",
		L"Experiment with different weapons and gear in Ironman; adapt your strategies to overcome various monster types and situations.",
		L"Keep a close watch on your hirelings' health in Ironman; losing a hireling means losing their equipped items as well.",
		L"Plan and communicate effectively in MultiPlayer Ironman games; teamwork and coordination are key to overcoming challenges.",
		L"Be conservative with resources in Hardcore Ironman; strategic planning and careful execution are vital for survival.",
		L"Craft rare, set, unique items using collected item parts and smithing hammers in Ironman; choose item types wisely for your build.",
		L"Capture and corrupt items using Talisman of Corruption for new magical properties in Ironman; take calculated risks for potential rewards.",
		L"Use Portable Shrines strategically in Ironman for temporary buffs; timing and placement of shrines can turn the tide of battle.",
		L"Keep track of Souls Consumed and Spirits Quaffed stats in Ironman; they reflect your progress and resource utilization in the game.",
		L"Enhance your character with Elixirs and Stones for permanent stat boosts and bonuses in Ironman; plan your upgrades wisely.",
		L"Master the art of retreating and regrouping in Hardcore Ironman; strategic fallbacks can save your character's life in tough situations.",
		L"Stay vigilant and adapt your strategies in MultiPlayer Ironman games; synergy and cooperation with teammates are essential for success.",
		L"Experiment with different skill synergies and builds in Ironman; explore the full potential of your character's abilities.",
		L"Craft and equip powerful unique items using collected Magic Essence Points and recipes in Ironman; customize your gear for optimal performance.",
		L"Explore new areas and challenges in Ironman; discover hidden secrets and encounters by venturing off the beaten path.",
		L"Combine different magic, rare, set, unique items with the Energy Sphere to collect their magic energy in Ironman.",
		L"Cube white items with the Energy Sphere to break them down into simple item parts for crafting in Ironman.",
		L"Use smithing hammers with the Energy Sphere to create base item types for crafting in Ironman.",
		L"Combine Rare Shard, Set Stone, or Unique Particle with base item types and Magic Essence Points to create rare, set, unique, items in Ironman.",
		L"Cube Souls with the Energy Sphere to capture their energy and use it for creating more powerful items in Ironman.",

		L"Prioritize survivability over damage output. In Hardcore Ironman, staying alive is paramount.",
		L"Scout ahead before engaging enemies. Knowing what's coming can help you prepare and avoid deadly surprises.",
		L"Always have an escape route planned. Without town portals, strategic positioning and waypoints are your lifelines.",
		L"Collect and hoard potions. You never know when you'll need a sudden burst of healing or mana.",
		L"Experiment with different skill combinations. Adaptability is key to overcoming the diverse challenges of Hardcore mode.",
		L"Know your enemy. Understanding monster types and behaviors can give you a significant advantage in combat.",
		L"Stock up on antidote and thawing potions. Poison and cold damage are particularly deadly in Hardcore.",
		L"Maintain a diverse arsenal of weapons and armor. You never know when you'll need a specific resistance or damage type.",
		L"Train your mercenary well. They can be a valuable asset in battles, providing support and distraction when needed.",
		L"Don't be afraid to retreat. Sometimes, discretion is the better part of valor in Hardcore Ironman.",
		L"Watch your surroundings. Traps and ambushes can quickly turn a routine exploration into a fight for survival.",
		L"Stay informed about the latest patches and updates. Changes to game mechanics can have a significant impact on Hardcore gameplay.",
		L"Join Hardcore Ironman communities. Sharing tips and strategies with fellow players can enhance your survival chances.",
		L"Back up your save files regularly. Losing a Hardcore character to a technical glitch can be devastating.",
		L"Practice patience and caution. Rushing into battles recklessly is a surefire way to meet an untimely demise.",
		L"Embrace the challenge. Hardcore Ironman may be unforgiving, but overcoming its trials is immensely rewarding.",
		L"Develop a keen eye for loot. Every item could be the difference between life and death in Hardcore mode.",
		L"Learn from your mistakes. Each death is an opportunity to refine your strategies and become a better Hardcore player.",
		L"Respect your limits. Sometimes, it's better to retreat and live to fight another day than to press on recklessly.",
		L"Communicate with your party. Clear communication can prevent misunderstandings and ensure everyone's safety.",
		L"Stay focused. Even the smallest lapse in concentration can be fatal in Hardcore Ironman.",
		L"Build a strong network of allies. Having friends to watch your back can make all the difference in Hardcore mode.",
		L"Experiment with different character builds. There's no one-size-fits-all approach to Hardcore survival.",
		L"Avoid unnecessary risks. The thrill of danger may be tempting, but it's not worth losing your Hardcore character over.",
		L"Take breaks when needed. Hardcore Ironman can be mentally exhausting, so don't hesitate to step away and recharge.",
		L"Stay vigilant at all times. Complacency is the enemy of survival in Hardcore mode.",
		L"Adapt to changing circumstances. Flexibility is key to thriving in the ever-evolving world of Hardcore Ironman.",
		L"Trust your instincts. Sometimes, your gut feeling is your best guide in Hardcore survival.",
		L"Never underestimate your enemies. Even the weakest foes can pose a threat in Hardcore mode.",
		L"Explore every corner of the map. You never know what valuable resources or hidden dangers you might uncover.",
		L"Prepare for the worst. Always have a backup plan in case things go south in Hardcore Ironman.",
		L"Keep your equipment in top condition. A well-maintained arsenal can mean the difference between victory and defeat.",
		L"Study the terrain. Knowing the lay of the land can give you a strategic advantage in Hardcore battles.",
		L"Coordinate your attacks with your party members. Working together is essential for success in Hardcore mode.",
		L"Be mindful of your surroundings. Environmental hazards can be just as deadly as enemy attacks in Hardcore Ironman.",
		L"Stay cool under pressure. Panicking will only lead to mistakes and, ultimately, your demise in Hardcore mode.",
		L"Focus on survival skills first. Offensive prowess means nothing if you can't stay alive in Hardcore Ironman.",
		L"Be wary of traps and ambushes. The world of Hardcore is full of dangers lurking around every corner.",
		L"Pay attention to your health and mana reserves. Running out at the wrong moment can be fatal in Hardcore mode.",
		L"Plan your routes carefully. Avoiding unnecessary risks is crucial in Hardcore Ironman.",
		L"Learn from the mistakes of others. Watching other Hardcore players can provide valuable insights into effective survival strategies.",
		L"Stay disciplined in your gameplay. Taking unnecessary risks can quickly lead to your demise in Hardcore mode.",
		L"Keep a clear head. Emotional decisions are rarely the right ones in Hardcore Ironman.",
		L"Learn to prioritize threats. Not every enemy is worth engaging in Hardcore mode.",
		L"Practice patience. Rushing into battles blindly is a surefire way to meet a premature end in Hardcore Ironman.",
		L"Stockpile essential supplies. You never know when you'll need that extra potion or scroll in Hardcore mode.",
		L"Be proactive in your approach. Waiting for danger to come to you is a recipe for disaster in Hardcore Ironman.",
		L"Stay informed about the latest strategies and tactics. Knowledge is power in Hardcore mode.",
		L"Stay humble. Arrogance is a sure path to failure in Hardcore Ironman.",
		L"Trust your instincts. If something feels wrong, it probably is in Hardcore mode.",
		L"Take calculated risks. Sometimes, a bold move is necessary to secure victory in Hardcore Ironman.",
		L"Keep your wits about you. Panic is the enemy of survival in Hardcore mode.",
		L"Never let your guard down. Complacency is a luxury you can't afford in Hardcore Ironman.",
		L"Respect the power of your enemies. Underestimating them is a sure path to defeat in Hardcore mode.",
		L"Stay focused on your goals. Losing sight of your objectives can lead to costly mistakes in Hardcore Ironman.",
		L"Adapt to adversity. Flexibility is key to surviving the ever-changing challenges of Hardcore mode.",
		L"Stay vigilant. Danger can lurk around every corner in Hardcore Ironman.",
		L"Know when to retreat. Sometimes, discretion is the better part of valor in Hardcore mode.",
		L"Be mindful of your surroundings. Environmental hazards can be just as deadly as enemy attacks in Hardcore Ironman.",
		L"Stay cool under pressure. Panicking will only lead to mistakes and, ultimately, your demise in Hardcore mode.",
		L"Focus on survival skills first. Offensive prowess means nothing if you can't stay alive in Hardcore Ironman.",
		L"Be wary of traps and ambushes. The world of Hardcore is full of dangers lurking around every corner.",
		L"Pay attention to your health and mana reserves. Running out at the wrong moment can be fatal in Hardcore mode.",
		L"Plan your routes carefully. Avoiding unnecessary risks is crucial in Hardcore Ironman.",
		L"Learn from the mistakes of others. Watching other Hardcore players can provide valuable insights into effective survival strategies.",
		L"Stay disciplined in your gameplay. Taking unnecessary risks can quickly lead to your demise in Hardcore mode.",
		L"Keep a clear head. Emotional decisions are rarely the right ones in Hardcore Ironman.",
		L"Learn to prioritize threats. Not every enemy is worth engaging in Hardcore mode.",
		L"Practice patience. Rushing into battles blindly is a surefire way to meet a premature end in Hardcore Ironman.",
		L"Stockpile essential supplies. You never know when you'll need that extra potion or scroll in Hardcore mode.",
		L"Be proactive in your approach. Waiting for danger to come to you is a recipe for disaster in Hardcore Ironman.",
		L"Stay informed about the latest strategies and tactics. Knowledge is power in Hardcore mode.",
		L"Stay humble. Arrogance is a sure path to failure in Hardcore Ironman.",
		L"Trust your instincts. If something feels wrong, it probably is in Hardcore mode.",
		L"Take calculated risks. Sometimes, a bold move is necessary to secure victory in Hardcore Ironman.",
		L"Keep your wits about you. Panic is the enemy of survival in Hardcore mode.",
		L"Never let your guard down. Complacency is a luxury you can't afford in Hardcore Ironman.",
		L"Respect the power of your enemies. Underestimating them is a sure path to defeat in Hardcore mode.",
		L"Stay focused on your goals. Losing sight of your objectives can lead to costly mistakes in Hardcore Ironman.",
		L"Adapt to adversity. Flexibility is key to surviving the ever-changing challenges of Hardcore mode.",
		L"Stay vigilant. Danger can lurk around every corner in Hardcore Ironman.",
		L"Know when to retreat. Sometimes, discretion is the better part of valor in Hardcore mode.",

		L"In Hardcore Ironman, survival is your top priority. Every decision you make should revolve around keeping your character alive in the harsh world of Diablo 2.",
		L"Take your time to carefully explore each area, scanning for potential threats and planning your route accordingly. Rushing into battles or unknown territory is a surefire way to meet an untimely demise.",
		L"Without the safety net of town portals, strategic planning is essential. Always have an escape route in mind, whether it's a nearby waypoint or a path back to a safe area.",
		L"Inventory management is critical in Hardcore mode. Keep your inventory organized and prioritize essential items like potions, scrolls, and emergency gear.",
		L"Be cautious when engaging enemies. Assess their strengths and weaknesses before committing to battle, and don't hesitate to retreat if the odds are against you.",
		L"Experiment with different skill combinations and character builds to find what works best for your playstyle. Adaptability is key to surviving the challenges of Hardcore Ironman.",
		L"Study your surroundings and learn to anticipate potential dangers. Traps, ambushes, and environmental hazards can quickly turn a routine exploration into a fight for survival.",
		L"Maintain a diverse arsenal of weapons and armor to handle a variety of threats. Prioritize gear that boosts your resistances and provides additional layers of protection.",
		L"Train your mercenary companion well and equip them with gear that complements your own strengths and weaknesses. They can provide invaluable support in battles and serve as a valuable distraction for enemies.",
		L"Communication is key, especially in multiplayer games. Coordinate with your party members and share information about enemy locations, tactics, and potential dangers.",
		L"Stay informed about the latest strategies, tactics, and updates. Knowledge is power in Hardcore mode, and being aware of changes to the game can give you a significant advantage.",
		L"Develop a backup plan for emergencies. Whether it's a stash of emergency potions or a hidden escape route, always have a contingency plan in place.",
		L"Practice patience and resilience. Setbacks and challenges are inevitable in Hardcore Ironman, but perseverance will ultimately lead to success.",
		L"Build a network of allies and fellow Hardcore players. Sharing tips, strategies, and experiences can help you learn and grow as a player.",
		L"Trust your instincts and intuition. If something feels wrong or too risky, it's better to err on the side of caution.",
		L"Embrace the challenge of Hardcore Ironman and enjoy the thrill of survival. The adrenaline rush of narrowly escaping death is what makes Hardcore mode so rewarding.",
		L"Stay disciplined in your gameplay and avoid taking unnecessary risks. Remember, one wrong move can cost you your character in Hardcore mode.",
		L"Keep a cool head and stay focused, especially in intense or dangerous situations. Panic and fear are your worst enemies in Hardcore Ironman.",
		L"Learn from your mistakes and use them as opportunities for growth. Every death is a chance to refine your strategies and improve your gameplay.",
		L"Be mindful of your surroundings at all times. Even the smallest oversight can prove fatal in Hardcore mode.",
		L"Prioritize defensive stats and survival skills over offensive abilities. A strong defense is crucial for staying alive in Hardcore Ironman.",
		L"Stockpile essential supplies like potions, scrolls, and emergency gear. You never know when you'll need them in Hardcore mode.",
		L"Plan your routes carefully and avoid unnecessary risks. Rushing headlong into danger is a recipe for disaster in Hardcore Ironman.",
		L"Stay adaptable and be prepared to adjust your tactics on the fly. The ability to think quickly and react to changing situations is essential for survival in Hardcore mode.",
		L"Coordinate your actions with your party members and work together to overcome challenges. Teamwork is key to success in Hardcore Ironman.",
		L"Be cautious when exploring new areas, especially in Hardcore mode. Unknown dangers lurk around every corner, and it's better to proceed with caution than to rush in blindly.",
		L"Equip gear that complements your playstyle and provides the best possible protection against enemy attacks. Prioritize resistances and defensive bonuses over offensive stats in Hardcore mode.",
		L"Stay informed about the strengths and weaknesses of different enemy types. Knowing your foes is essential for developing effective strategies and staying alive in Hardcore Ironman.",
		L"Practice patience and perseverance in Hardcore mode. Success often requires multiple attempts and learning from your mistakes.",
		L"Develop a backup plan for emergencies, such as a stash of emergency potions or a hidden escape route. Always have a contingency plan in place in Hardcore mode.",
		L"Coordinate your actions with your party members and communicate effectively to overcome challenges together. Teamwork is essential for survival in Hardcore Ironman.",
		L"Stay vigilant and be prepared for anything in Hardcore mode. Unexpected dangers and challenges can arise at any moment, and it's important to stay alert.",
		L"Learn from your mistakes and use them as opportunities for growth. Every death is a chance to refine your strategies and become a better Hardcore player.",
		L"Stock up on essential supplies like potions, scrolls, and emergency gear. You never know when you'll need them in Hardcore mode.",
		L"Plan your routes carefully and avoid unnecessary risks. Rushing into danger blindly is a surefire way to meet an untimely demise in Hardcore Ironman.",
		L"Stay adaptable and be prepared to adjust your tactics on the fly. Flexibility is key to surviving the ever-changing challenges of Hardcore mode.",
		L"Coordinate your actions with your party members and work together to overcome challenges. Teamwork is essential for success in Hardcore Ironman.",
		L"Be cautious when exploring new areas, especially in Hardcore mode. Unknown dangers lurk around every corner, and it's better to proceed with caution than to rush in blindly.",
		L"Equip gear that complements your playstyle and provides the best possible protection against enemy attacks. Prioritize defensive bonuses and resistances over offensive stats in Hardcore mode.",
		L"Stay informed about the strengths and weaknesses of different enemy types. Knowing your foes is essential for developing effective strategies and staying alive in Hardcore Ironman.",
		L"Practice patience and perseverance in Hardcore mode. Success often requires multiple attempts and learning from your mistakes.",
		L"Develop a backup plan for emergencies, such as a stash of emergency potions or a hidden escape route. Always have a contingency plan in place in Hardcore mode.",
		L"Coordinate your actions with your party members and communicate effectively to overcome challenges together. Teamwork is essential for survival in Hardcore Ironman.",
		L"Stay vigilant and be prepared for anything in Hardcore mode. Unexpected dangers and challenges can arise at any moment, and it's important to stay alert.",
		L"Learn from your mistakes and use them as opportunities for growth. Every death is a chance to refine your strategies and become a better Hardcore player.",
		L"Stock up on essential supplies like potions, scrolls, and emergency gear. You never know when you'll need them in Hardcore mode.",
		L"Plan your routes carefully and avoid unnecessary risks. Rushing into danger blindly is a surefire way to meet an untimely demise in Hardcore Ironman.",
		L"Stay adaptable and be prepared to adjust your tactics on the fly. Flexibility is key to surviving the ever-changing challenges of Hardcore mode.",
		L"Coordinate your actions with your party members and work together to overcome challenges. Teamwork is essential for success in Hardcore Ironman.",
		L"Be cautious when exploring new areas, especially in Hardcore mode. Unknown dangers lurk around every corner, and it's better to proceed with caution than to rush in blindly.",
		L"Equip gear that complements your playstyle and provides the best possible protection against enemy attacks. Prioritize defensive bonuses and resistances over offensive stats in Hardcore mode.",
		L"Stay informed about the strengths and weaknesses of different enemy types. Knowing your foes is essential for developing effective strategies and staying alive in Hardcore Ironman.",
		L"Practice patience and perseverance in Hardcore mode. Success often requires multiple attempts and learning from your mistakes.",
		L"Develop a backup plan for emergencies, such as a stash of emergency potions or a hidden escape route. Always have a contingency plan in place in Hardcore mode.",
		L"Coordinate your actions with your party members and communicate effectively to overcome challenges together. Teamwork is essential for survival in Hardcore Ironman.",
		L"Stay vigilant and be prepared for anything in Hardcore mode. Unexpected dangers and challenges can arise at any moment, and it's important to stay alert.",
		L"Learn from your mistakes and use them as opportunities for growth. Every death is a chance to refine your strategies and become a better Hardcore player.",
		L"Stock up on essential supplies like potions, scrolls, and emergency gear. You never know when you'll need them in Hardcore mode.",
		L"Plan your routes carefully and avoid unnecessary risks. Rushing into danger blindly is a surefire way to meet an untimely demise in Hardcore Ironman.",
		L"Stay adaptable and be prepared to adjust your tactics on the fly. Flexibility is key to surviving the ever-changing challenges of Hardcore mode.",
		L"Coordinate your actions with your party members and work together to overcome challenges. Teamwork is essential for success in Hardcore Ironman.",
		L"Be cautious when exploring new areas, especially in Hardcore mode. Unknown dangers lurk around every corner, and it's better to proceed with caution than to rush in blindly.",
		L"Equip gear that complements your playstyle and provides the best possible protection against enemy attacks. Prioritize defensive bonuses and resistances over offensive stats in Hardcore mode.",
		L"Stay informed about the strengths and weaknesses of different enemy types. Knowing your foes is essential for developing effective strategies and staying alive in Hardcore Ironman.",
		L"Practice patience and perseverance in Hardcore mode. Success often requires multiple attempts and learning from your mistakes.",
		L"Develop a backup plan for emergencies, such as a stash of emergency potions or a hidden escape route. Always have a contingency plan in place in Hardcore mode.",
		L"Coordinate your actions with your party members and communicate effectively to overcome challenges together. Teamwork is essential for survival in Hardcore Ironman.",
		L"Stay vigilant and be prepared for anything in Hardcore mode. Unexpected dangers and challenges can arise at any moment, and it's important to stay alert.",
		L"Learn from your mistakes and use them as opportunities for growth. Every death is a chance to refine your strategies and become a better Hardcore player.",
		L"Stock up on essential supplies like potions, scrolls, and emergency gear. You never know when you'll need them in Hardcore mode.",
		L"Plan your routes carefully and avoid unnecessary risks. Rushing into danger blindly is a surefire way to meet an untimely demise in Hardcore Ironman.",
		L"Stay adaptable and be prepared to adjust your tactics on the fly. Flexibility is key to surviving the ever-changing challenges of Hardcore mode.",
		L"Coordinate your actions with your party members and work together to overcome challenges. Teamwork is essential for success in Hardcore Ironman.",
		L"Be cautious when exploring new areas, especially in Hardcore mode. Unknown dangers lurk around every corner, and it's better to proceed with caution than to rush in blindly.",
		L"Equip gear that complements your playstyle and provides the best possible protection against enemy attacks. Prioritize defensive bonuses and resistances over offensive stats in Hardcore mode.",
		L"Stay informed about the strengths and weaknesses of different enemy types. Knowing your foes is essential for developing effective strategies and staying alive in Hardcore Ironman.",
		L"Practice patience and perseverance in Hardcore mode. Success often requires multiple attempts and learning from your mistakes.",
		L"Develop a backup plan for emergencies, such as a stash of emergency potions or a hidden escape route. Always have a contingency plan in place in Hardcore mode.",
		L"Coordinate your actions with your party members and communicate effectively to overcome challenges together. Teamwork is essential for survival in Hardcore Ironman.",
		L"Stay vigilant and be prepared for anything in Hardcore mode. Unexpected dangers and challenges can arise at any moment, and it's important to stay alert.",
		L"Learn from your mistakes and use them as opportunities for growth. Every death is a chance to refine your strategies and become a better Hardcore player.",

		L"Stock up on essential supplies like potions, scrolls, and emergency gear. You never know when you'll need them in Hardcore mode.",

		L"In Hardcore Ironman, your character's survival is paramount above all else. Every decision you make, every action you take, should be with the singular goal of keeping your character alive in the unforgiving world of Diablo 2.",
		L"Before engaging enemies or venturing into unknown territory, take the time to thoroughly scout your surroundings. Look for potential threats, plan escape routes, and assess the level of danger you may face.",
		L"With town portals disabled, strategic planning becomes even more critical. Always have a backup plan in place for emergencies, whether it's knowing the location of the nearest waypoint or having a stash of emergency supplies hidden away.",
		L"Effective inventory management can mean the difference between life and death in Hardcore mode. Organize your inventory carefully, prioritize essential items such as potions and scrolls, and be mindful of your carrying capacity at all times.",
		L"When facing challenging foes or uncertain situations, don't hesitate to retreat and regroup if necessary. Survival in Hardcore Ironman requires patience, caution, and a willingness to make strategic withdrawals when the odds are against you.",
		L"Experiment with different skill builds and character setups to find what works best for your playstyle and the challenges you face. Adaptability and versatility are key attributes for success in Hardcore mode.",
		L"Stay vigilant and be constantly aware of your surroundings. Traps, ambushes, and environmental hazards can pose just as much of a threat as enemy attacks, so always proceed with caution and remain alert.",
		L"Equip gear that emphasizes defense and survivability over offensive power. Prioritize items with high resistances, damage reduction, and life-saving bonuses to maximize your chances of survival in Hardcore Ironman.",
		L"Your mercenary companion can be a valuable asset in Hardcore mode, providing additional firepower, support, and distraction in battle. Invest in their equipment and skills wisely to ensure they can effectively complement your own abilities.",
		L"In multiplayer games, effective communication and cooperation are essential for survival. Coordinate with your party members, share information about enemy locations and tactics, and work together to overcome challenges.",

		L"Stay informed about the latest updates, patches, and strategies in the Diablo 2 community. Knowledge is power in Hardcore mode, and staying up-to-date with the latest developments can give you a significant advantage.",
		L"Develop a contingency plan for emergencies. Whether it's having a reserve of emergency potions, escape routes planned out in advance, or backup characters ready to take over in case of death, always be prepared for the worst-case scenario.",
		L"Practice patience and resilience in the face of adversity. Setbacks and challenges are inevitable in Hardcore Ironman, but maintaining a positive mindset and persevering through tough times is key to ultimate success.",
		L"Build connections with other Hardcore players and join communities or forums where you can share tips, strategies, and experiences. Learning from the insights of others can help you improve your own Hardcore gameplay.",
		L"Trust your instincts and intuition when navigating the dangers of Hardcore mode. If something feels too risky or dangerous, don't hesitate to err on the side of caution and take a safer approach.",
		L"Embrace the thrill and challenge of Hardcore Ironman, and savor the adrenaline rush that comes with narrowly escaping death. The high stakes and permanent consequences make every victory all the more rewarding in Hardcore mode.",
		L"Maintain discipline and avoid taking unnecessary risks that could jeopardize your character's survival. Exercise caution in all your actions, and remember that one careless mistake could cost you dearly in Hardcore Ironman.",
		L"Keep a clear mind and remain focused, especially during intense or dangerous situations. Panic and anxiety can cloud your judgment and lead to fatal errors in Hardcore mode, so strive to stay calm and composed at all times.",
		L"Learn from your mistakes and use each death as an opportunity for growth and improvement. Analyze what went wrong, identify areas for improvement, and apply those lessons to future gameplay to become a stronger Hardcore player.",
		L"Be vigilant and attentive to your surroundings, as danger can lurk around every corner in Hardcore mode. Take nothing for granted, and always be prepared to react quickly to unexpected threats or challenges.",
		L"Prioritize defensive capabilities and survival skills when choosing gear and allocating skill points. A sturdy defense and reliable survivability are essential for weathering the dangers of Hardcore Ironman.",
		L"Stock up on essential supplies such as potions, scrolls, and emergency gear to ensure you're always prepared for whatever challenges may arise in Hardcore mode. It's better to have too much than too little when your life is on the line.",
		L"Plan your routes and engagements carefully, avoiding unnecessary risks and ensuring you always have a viable escape plan. Rushing headlong into danger is a surefire way to meet an untimely end in Hardcore Ironman.",
		L"Remain adaptable and flexible in your approach, adjusting your tactics and strategies as needed to overcome the ever-changing challenges of Hardcore mode. The ability to think on your feet and adapt to new situations is crucial for survival.",
		L"Communicate effectively with your party members in multiplayer games, coordinating your actions and sharing information to maximize your chances of success. Teamwork is essential for conquering the toughest challenges in Hardcore Ironman.",
		L"Exercise caution and prudence when exploring new areas, taking care to avoid potential traps, ambushes, and other hazards that could spell doom for your character. Proceed with caution and always be prepared for the unexpected.",
		L"Equip gear that emphasizes defensive bonuses and survivability over raw offensive power, prioritizing items that offer high resistances, damage reduction, and other life-saving properties. In Hardcore mode, staying alive is the ultimate goal.",
		L"Study the strengths and weaknesses of different enemy types, learning their attack patterns and behaviors to better anticipate and counter their threats. Knowledge is power in Hardcore Ironman, and understanding your foes is key to victory.",
		L"Embrace the virtues of patience and perseverance, knowing that success in Hardcore mode often requires multiple attempts and learning from your mistakes. Stay determined and keep pushing forward, even in the face of adversity.",
		L"Develop a backup plan for emergencies, ensuring you have contingencies in place for unexpected situations such as running out of potions or finding yourself cornered by powerful enemies. Preparation is key to survival in Hardcore Ironman.",
		L"Coordinate your actions with your party members, leveraging each other's strengths and abilities to overcome challenges that would be insurmountable alone. In Hardcore mode, teamwork can mean the difference between life and death.",
		L"Remain vigilant and alert at all times, keeping a watchful eye on your surroundings and being prepared to react swiftly to any threats or dangers that may arise. In Hardcore Ironman, constant vigilance is essential for survival.",
		L"Learn from your mistakes and use each death as an opportunity for growth and improvement. Analyze what went wrong, identify areas for improvement, and apply those lessons to your future gameplay to become a stronger and more resilient Hardcore player.",
		L"Stock up on essential supplies such as potions, scrolls, and emergency gear to ensure you're always prepared for whatever challenges may arise in Hardcore mode. It's better to have too much than too little when your life is on the line.",
		L"Plan your routes and engagements carefully, avoiding unnecessary risks and ensuring you always have a viable escape plan. Rushing headlong into danger is a surefire way to meet an untimely end in Hardcore Ironman.",
		L"Remain adaptable and flexible in your approach, adjusting your tactics and strategies as needed to overcome the ever-changing challenges of Hardcore mode. The ability to think on your feet and adapt to new situations is crucial for survival.",
		L"Communicate effectively with your party members in multiplayer games, coordinating your actions and sharing information to maximize your chances of success. Teamwork is essential for conquering the toughest challenges in Hardcore Ironman.",
		L"Exercise caution and prudence when exploring new areas, taking care to avoid potential traps, ambushes, and other hazards that could spell doom for your character. Proceed with caution and always be prepared for the unexpected.",
		L"Equip gear that emphasizes defensive bonuses and survivability over raw offensive power, prioritizing items that offer high resistances, damage reduction, and other life-saving properties. In Hardcore mode, staying alive is the ultimate goal.",
		L"Study the strengths and weaknesses of different enemy types, learning their attack patterns and behaviors to better anticipate and counter their threats. Knowledge is power in Hardcore Ironman, and understanding your foes is key to victory.",
		L"Embrace the virtues of patience and perseverance, knowing that success in Hardcore mode often requires multiple attempts and learning from your mistakes. Stay determined and keep pushing forward, even in the face of adversity.",
		L"Develop a backup plan for emergencies, ensuring you have contingencies in place for unexpected situations such as running out of potions or finding yourself cornered by powerful enemies. Preparation is key to survival in Hardcore Ironman.",
		L"Coordinate your actions with your party members, leveraging each other's strengths and abilities to overcome challenges that would be insurmountable alone. In Hardcore mode, teamwork can mean the difference between life and death.",
		L"Remain vigilant and alert at all times, keeping a watchful eye on your surroundings and being prepared to react swiftly to any threats or dangers that may arise. In Hardcore Ironman, constant vigilance is essential for survival.",

		L"In Hardcore Ironman, survival is your top priority. Every decision you make, every action you take, should be with the singular goal of keeping your character alive in the unforgiving world of Diablo 2.",
		L"Before engaging enemies or venturing into unknown territory, take the time to thoroughly scout your surroundings. Look for potential threats, plan escape routes, and assess the level of danger you may face.",
		L"With town portals disabled, strategic planning becomes even more critical. Always have a backup plan in place for emergencies, whether it's knowing the location of the nearest waypoint or having a stash of emergency supplies hidden away.",
		L"Effective inventory management can mean the difference between life and death in Hardcore mode. Organize your inventory carefully, prioritize essential items such as potions and scrolls, and be mindful of your carrying capacity at all times.",
		L"When facing challenging foes or uncertain situations, don't hesitate to retreat and regroup if necessary. Survival in Hardcore Ironman requires patience, caution, and a willingness to make strategic withdrawals when the odds are against you.",
		L"Experiment with different skill builds and character setups to find what works best for your playstyle and the challenges you face. Adaptability and versatility are key attributes for success in Hardcore mode.",
		L"Stay vigilant and be constantly aware of your surroundings. Traps, ambushes, and environmental hazards can pose just as much of a threat as enemy attacks, so always proceed with caution and remain alert.",
		L"Equip gear that emphasizes defense and survivability over offensive power. Prioritize items with high resistances, damage reduction, and life-saving bonuses to maximize your chances of survival in Hardcore Ironman.",
		L"Your mercenary companion can be a valuable asset in Hardcore mode, providing additional firepower, support, and distraction in battle. Invest in their equipment and skills wisely to ensure they can effectively complement your own abilities.",
		L"In multiplayer games, effective communication and cooperation are essential for survival. Coordinate with your party members, share information about enemy locations and tactics, and work together to overcome challenges and dangers.",
		L"Stay informed about the latest updates, patches, and strategies in the Diablo 2 community. Knowledge is power in Hardcore mode, and staying up-to-date with the latest developments can give you a significant advantage.",
		L"Develop a contingency plan for emergencies. Whether it's having a reserve of emergency potions, escape routes planned out in advance, or backup characters ready to take over in case of death, always be prepared for the worst-case scenario.",
		L"Practice patience and resilience in the face of adversity. Setbacks and challenges are inevitable in Hardcore Ironman, but maintaining a positive mindset and persevering through tough times is key to ultimate success.",
		L"Build connections with other Hardcore players and join communities or forums where you can share tips, strategies, and experiences. Learning from the insights of others can help you improve your own Hardcore gameplay.",
		L"Trust your instincts and intuition when navigating the dangers of Hardcore mode. If something feels too risky or dangerous, don't hesitate to err on the side of caution and take a safer approach.",
		L"Embrace the thrill and challenge of Hardcore Ironman, and savor the adrenaline rush that comes with narrowly escaping death. The high stakes and permanent consequences make every victory all the more rewarding in Hardcore mode.",
		L"Maintain discipline and avoid taking unnecessary risks that could jeopardize your character's survival. Exercise caution in all your actions, and remember that one careless mistake could cost you dearly in Hardcore Ironman.",
		L"Keep a clear mind and remain focused, especially during intense or dangerous situations. Panic and anxiety can cloud your judgment and lead to fatal errors in Hardcore mode, so strive to stay calm and composed at all times.",
		L"Learn from your mistakes and use each death as an opportunity for growth and improvement. Analyze what went wrong, identify areas for improvement, and apply those lessons to future gameplay to become a stronger Hardcore player.",
		L"Be vigilant and attentive to your surroundings, as danger can lurk around every corner in Hardcore mode. Take nothing for granted, and always be prepared to react quickly to unexpected threats or challenges.",
		L"Prioritize defensive capabilities and survival skills when choosing gear and allocating skill points. A sturdy defense and reliable survivability are essential for weathering the dangers of Hardcore Ironman.",
		L"Stock up on essential supplies such as potions, scrolls, and emergency gear to ensure you're always prepared for whatever challenges may arise in Hardcore mode. It's better to have too much than too little when your life is on the line.",
		L"Plan your routes and engagements carefully, avoiding unnecessary risks and ensuring you always have a viable escape plan. Rushing headlong into danger is a surefire way to meet an untimely end in Hardcore Ironman.",
		L"Remain adaptable and flexible in your approach, adjusting your tactics and strategies as needed to overcome the ever-changing challenges of Hardcore mode. The ability to think on your feet and adapt to new situations is crucial for survival.",
		L"Communicate effectively with your party members in multiplayer games, coordinating your actions and sharing information to maximize your chances of success. Teamwork is essential for conquering the toughest challenges in Hardcore Ironman.",
		L"Exercise caution and prudence when exploring new areas, taking care to avoid potential traps, ambushes, and other hazards that could spell doom for your character. Proceed with caution and always be prepared for the unexpected.",
		L"Equip gear that emphasizes defensive bonuses and survivability over raw offensive power, prioritizing items that offer high resistances, damage reduction, and other life-saving properties. In Hardcore mode, staying alive is the ultimate goal.",
		L"Study the strengths and weaknesses of different enemy types, learning their attack patterns and behaviors to better anticipate and counter their threats. Knowledge is power in Hardcore Ironman, and understanding your foes is key to victory.",
		L"Embrace the virtues of patience and perseverance, knowing that success in Hardcore mode often requires multiple attempts and learning from your mistakes. Stay determined and keep pushing forward, even in the face of adversity.",
		L"Develop a backup plan for emergencies, ensuring you have contingencies in place for unexpected situations such as running out of potions or finding yourself cornered by powerful enemies. Preparation is key to survival in Hardcore Ironman.",
		L"Coordinate your actions with your party members, leveraging each other's strengths and abilities to overcome challenges that would be insurmountable alone. In Hardcore mode, teamwork can mean the difference between life and death.",
		L"Remain vigilant and alert at all times, keeping a watchful eye on your surroundings and being prepared to react swiftly to any threats or dangers that may arise. In Hardcore Ironman, constant vigilance is essential for survival.",
		L"Learn from your mistakes and use each death as an opportunity for growth and improvement. Analyze what went wrong, identify areas for improvement, and apply those lessons to your future gameplay to become a stronger and more resilient Hardcore player.",
		L"Stock up on essential supplies such as potions, scrolls, and emergency gear to ensure you're always prepared for whatever challenges may arise in Hardcore mode. It's better to have too much than too little when your life is on the line.",
		L"Plan your routes and engagements carefully, avoiding unnecessary risks and ensuring you always have a viable escape plan. Rushing headlong into danger is a surefire way to meet an untimely end in Hardcore Ironman.",
		L"Remain adaptable and flexible in your approach, adjusting your tactics and strategies as needed to overcome the ever-changing challenges of Hardcore mode. The ability to think on your feet and adapt to new situations is crucial for survival.",
		L"Communicate effectively with your party members in multiplayer games, coordinating your actions and sharing information to maximize your chances of success. Teamwork is essential for conquering the toughest challenges in Hardcore Ironman.",
		L"Exercise caution and prudence when exploring new areas, taking care to avoid potential traps, ambushes, and other hazards that could spell doom for your character. Proceed with caution and always be prepared for the unexpected.",
		L"Equip gear that emphasizes defensive bonuses and survivability over raw offensive power, prioritizing items that offer high resistances, damage reduction, and other life-saving properties. In Hardcore mode, staying alive is the ultimate goal.",
		L"Study the strengths and weaknesses of different enemy types, learning their attack patterns and behaviors to better anticipate and counter their threats. Knowledge is power in Hardcore Ironman, and understanding your foes is key to victory.",
		L"Embrace the virtues of patience and perseverance, knowing that success in Hardcore mode often requires multiple attempts and learning from your mistakes. Stay determined and keep pushing forward, even in the face of adversity.",
		L"Develop a backup plan for emergencies, ensuring you have contingencies in place for unexpected situations such as running out of potions or finding yourself cornered by powerful enemies. Preparation is key to survival in Hardcore Ironman.",
		L"Coordinate your actions with your party members, leveraging each other's strengths and abilities to overcome challenges that would be insurmountable alone. In Hardcore mode, teamwork can mean the difference between life and death.",
		L"Remain vigilant and alert at all times, keeping a watchful eye on your surroundings and being prepared to react swiftly to any threats or dangers that may arise. In Hardcore Ironman, constant vigilance is essential for survival."

		L"In Hardcore Ironman, the safety of your character is paramount. Every action you take should be calculated to ensure survival in the unforgiving world of Diablo 2. Take the time to carefully assess your surroundings, anticipate potential threats, and plan your actions accordingly.",
		L"With town portals disabled, strategic planning becomes even more crucial. Always have an exit strategy in mind, whether it's knowing the location of the nearest waypoint or having a designated escape route planned out in advance.",
		L"Effective inventory management is essential for survival in Hardcore mode. Keep your inventory organized, prioritize essential items such as potions and scrolls, and be mindful of your carrying capacity at all times.",
		L"When facing tough enemies or uncertain situations, don't be afraid to retreat and regroup if necessary. Survival in Hardcore Ironman requires patience, caution, and a willingness to reassess your approach when the odds are against you.",
		L"Experiment with different skill builds, character setups, and equipment combinations to find what works best for your playstyle and the challenges you encounter. Adaptability and versatility are key attributes for success in Hardcore mode.",
		L"Stay vigilant and remain constantly aware of your surroundings. Traps, ambushes, and environmental hazards can be just as deadly as enemy attacks, so always proceed with caution and keep your senses sharp.",
		L"Equip gear that prioritizes defense and survivability over offensive power. Look for items with high resistances, damage reduction, and life-saving bonuses to increase your chances of surviving the dangers of Hardcore Ironman.",
		L"Your mercenary companion can provide valuable support in Hardcore mode, serving as an additional source of damage, crowd control, and distraction in battle. Invest in their equipment and skills to ensure they can effectively complement your own abilities.",
		L"In multiplayer games, effective communication and cooperation are crucial for success. Coordinate with your party members, share information about enemy locations and tactics, and work together to overcome challenges and dangers.",
		L"Stay informed about the latest developments and strategies in the Diablo 2 community. Knowledge is power in Hardcore mode, and staying up-to-date with the latest information can give you a significant advantage.",
		L"Develop contingency plans for emergencies. Whether it's having a stash of emergency potions, designated escape routes planned out in advance, or backup characters ready to take over in case of death, always be prepared for the worst-case scenario.",
		L"Practice patience and resilience in the face of adversity. Setbacks and challenges are inevitable in Hardcore Ironman, but maintaining a positive attitude and persevering through tough times is essential for ultimate success.",
		L"Build connections with other Hardcore players and participate in communities or forums where you can share tips, strategies, and experiences. Learning from the insights of others can help you improve your own Hardcore gameplay.",
		L"Trust your instincts and intuition when navigating the dangers of Hardcore mode. If something feels too risky or dangerous, don't hesitate to err on the side of caution and take a safer approach.",
		L"Embrace the excitement and challenge of Hardcore Ironman, and relish the adrenaline rush that comes with narrowly escaping death. The high stakes and permanent consequences make every victory all the more satisfying in Hardcore mode.",
		L"Maintain discipline and avoid taking unnecessary risks that could jeopardize your character's survival. Exercise caution in all your actions, and remember that one careless mistake could cost you dearly in Hardcore Ironman.",
		L"Keep a clear head and stay focused, especially during intense or dangerous situations. Panic and fear can cloud your judgment and lead to fatal errors in Hardcore mode, so strive to remain calm and composed at all times.",
		L"Learn from your mistakes and view each death as an opportunity for growth and improvement. Analyze what went wrong, identify areas for improvement, and apply those lessons to your future gameplay to become a stronger Hardcore player.",
		L"Be vigilant and observant of your surroundings, as danger can lurk around every corner in Hardcore mode. Take nothing for granted, and always be prepared to react swiftly to unexpected threats or challenges.",
		L"Prioritize defensive capabilities and survival skills when choosing gear and allocating skill points. A solid defense and reliable survivability are essential for withstanding the dangers of Hardcore Ironman.",
		L"Stock up on essential supplies such as potions, scrolls, and emergency gear to ensure you're always prepared for whatever challenges may arise in Hardcore mode. It's better to have too much than too little when your life is on the line.",
		L"Plan your routes and engagements carefully, avoiding unnecessary risks and ensuring you always have a viable escape plan. Charging headlong into danger is a surefire way to meet an untimely end in Hardcore Ironman.",
		L"Remain adaptable and flexible in your approach, adjusting your tactics and strategies as needed to overcome the ever-changing challenges of Hardcore mode. The ability to think on your feet and adapt to new situations is crucial for survival.",
		L"Communicate effectively with your party members in multiplayer games, coordinating your actions and sharing information to maximize your chances of success. Teamwork is essential for overcoming the toughest challenges in Hardcore Ironman.",
		L"Exercise caution and prudence when exploring new areas, taking care to avoid potential traps, ambushes, and other hazards that could spell doom for your character. Proceed with caution and always be prepared for the unexpected.",
		L"Equip gear that emphasizes defensive bonuses and survivability over raw offensive power, prioritizing items that offer high resistances, damage reduction, and other life-saving properties. In Hardcore mode, staying alive is paramount.",
		L"Study the strengths and weaknesses of different enemy types, familiarizing yourself with their attack patterns and behaviors to better anticipate and counter their threats. Knowledge is power in Hardcore Ironman, and understanding your foes is key to victory.",
		L"Embrace the virtues of patience and perseverance, recognizing that success in Hardcore mode often requires multiple attempts and learning from your mistakes. Stay determined and keep pushing forward, even when the odds seem stacked against you.",
		L"Develop backup plans for emergencies, ensuring you have contingencies in place for unexpected situations such as running out of potions or finding yourself cornered by powerful enemies. Preparation is key to survival in Hardcore Ironman.",
		L"Coordinate your actions with your party members, leveraging each other's strengths and abilities to overcome challenges that would be insurmountable alone. In Hardcore mode, teamwork can be the difference between life and death.",
		L"Remain vigilant and alert at all times, maintaining a keen awareness of your surroundings and being prepared to react swiftly to any threats or dangers that may arise. In Hardcore Ironman, constant vigilance is essential for survival.",
		L"Learn from your mistakes and view each death as an opportunity for growth and improvement. Reflect on what went wrong, identify areas for improvement, and apply those lessons to your future gameplay to become a more skilled Hardcore player.",
		L"Stock up on essential supplies such as potions, scrolls, and emergency gear to ensure you're always prepared for whatever challenges may arise in Hardcore mode. It's better to have too much than too little when your life is on the line.",
		L"Plan your routes and engagements carefully, avoiding unnecessary risks and ensuring you always have a viable escape plan. Charging headlong into danger is a surefire way to meet an untimely end in Hardcore Ironman.",
		L"Remain adaptable and flexible in your approach, adjusting your tactics and strategies as needed to overcome the ever-changing challenges of Hardcore mode. The ability to think on your feet and adapt to new situations is crucial for survival.",
		L"Communicate effectively with your party members in multiplayer games, coordinating your actions and sharing information to maximize your chances of success. Teamwork is essential for overcoming the toughest challenges in Hardcore Ironman.",
		L"Exercise caution and prudence when exploring new areas, taking care to avoid potential traps, ambushes, and other hazards that could spell doom for your character. Proceed with caution and always be prepared for the unexpected.",
		L"Equip gear that emphasizes defensive bonuses and survivability over raw offensive power, prioritizing items that offer high resistances, damage reduction, and other life-saving properties. In Hardcore mode, staying alive is paramount.",
		L"Study the strengths and weaknesses of different enemy types, familiarizing yourself with their attack patterns and behaviors to better anticipate and counter their threats. Knowledge is power in Hardcore Ironman, and understanding your foes is key to victory.",
		L"Embrace the virtues of patience and perseverance, recognizing that success in Hardcore mode often requires multiple attempts and learning from your mistakes. Stay determined and keep pushing forward, even when the odds seem stacked against you.",
		L"Develop backup plans for emergencies, ensuring you have contingencies in place for unexpected situations such as running out of potions or finding yourself cornered by powerful enemies. Preparation is key to survival in Hardcore Ironman.",
		L"Coordinate your actions with your party members, leveraging each other's strengths and abilities to overcome challenges that would be insurmountable alone. In Hardcore mode, teamwork can be the difference between life and death.",
		L"Remain vigilant and alert at all times, maintaining a keen awareness of your surroundings and being prepared to react swiftly to any threats or dangers that may arise. In Hardcore Ironman, constant vigilance is essential for survival.",

		L"Discover the vast array of new sets introduced in the latest update, each offering unique bonuses and playstyles to explore. Experiment with different combinations to find the perfect set for your character's build and playstyle.",
		L"Explore the expansive collection of over 1400 new unique items, each with its own distinct attributes, affixes, and effects. From powerful weapons to protective armor, there's something for every type of character and playstyle.",
		L"Unlock the potential of hundreds of new runewords, each offering powerful bonuses and enhancements when socketed into your gear. Experiment with different combinations of runes to create the perfect runeword for your character's needs.",
		L"Delve into the world of gemwords, where combining multiple gems in your gear unlocks powerful bonuses and effects. With hundreds of gemwords to discover, there's endless potential for customization and optimization.",
		L"Discover the versatility of stonewords, which combine Diablo 3 gems with existing items to create powerful new gear with enhanced properties. Experiment with different gem combinations to find the perfect stoneword for your character.",
		L"Maximize the efficiency of your inventory management by utilizing the Magic Essence Harvester to extract essence from unwanted items. Convert magic, rare, set, or unique items into essence points, which can then be used to create new items and mods.",
		L"Utilize the Magic Essence Points obtained from the Harvester to create a wide variety of magic items and modifications. Whether you're enhancing existing gear or creating entirely new items, the possibilities are endless with Magic Essence Points.",
		L"Enhance your arsenal by using Rare Shards, Set Stones, or Unique Particles to create rare, set, and unique versions of items. Visit the NPC in town to access this feature and unlock the full potential of your gear.",
		L"Take advantage of Smithing Hammers, a new item type that drops in-game, to produce base item types for crafting custom gear. Use these base items as the foundation for creating powerful and unique equipment tailored to your character's needs.",
		L"Make use of the Item Salvager to break down white items and obtain valuable item parts for crafting. With a variety of salvaging options available, you can extract parts from different item qualities to fuel your crafting endeavors.",
		L"Explore the vast array of cube recipes added to the salvaging system, offering over 2,000 new combinations for extracting item parts and materials. Experiment with different recipes to discover the most efficient ways to salvage items and obtain resources.",
		L"Discover the excitement of Demon Souls and Spirits, which can be obtained from defeated demons. These unique drops offer valuable bonuses and enhancements, providing new opportunities for character customization and power-ups.",
		L"Organize your collection of gems and runes with Gem Bags and Rune Bags, which allow you to store and manage your precious resources more efficiently. With the ability to stack gems and runes up to 100 each, you'll have plenty of space for your collection.",
		L"Unlock the potential of full hireling inventory, allowing your hired companions to equip additional items such as belts, boots, gloves, rings, and amulets. Customize your hirelings to suit your needs and maximize their effectiveness in battle.",
		L"Access your stash from anywhere with the Remote Stash feature, which drops after achieving 10,000 kills. Enjoy the convenience of managing your inventory on the go, without the need to return to town or find a stash.",
		L"Increase your killcounter stat by slaying monsters and unlocking various bonuses and rewards based on your kill count. From healing potions to rare weapons and armor, there are plenty of incentives to keep pushing forward and defeating enemies.",
		L"Unlock Demon Chests and Keys by combining demon drops to receive random items of varying qualities. Experiment with different combinations to discover the treasures hidden within these mysterious chests.",
		L"Maximize the potential of your gear by socketing gems and runes into almost every item type, including helms, charms, boots, rings, amulets, shields, and belts. Customize your equipment to suit your playstyle and optimize your character's abilities.",
		L"Discover a wide range of magic, rare, and unique arrows and bolts, each offering unique properties and effects to enhance your ranged combat abilities. Experiment with different types to find the perfect ammunition for your character.",
		L"Unlock the power of magic, rare, and unique charms to bolster your character's stats and abilities. Whether you're seeking increased damage, resistance, or utility, there's a charm out there to suit your needs.",
		L"Explore the world of summoner doll charms, which offer unique bonuses and effects related to summoning and pet abilities. Enhance your summoner build with these specialized charms and unleash the full potential of your minions.",
		L"Experience the thrill of the Charmzone, where charms can only be utilized in the bottom four rows of your inventory. Strategically manage your charm inventory to optimize your character's performance in battle.",
		L"Collect monster body parts dropped by defeated enemies and use them to craft various items and enhancements. From resistance potions to elemental essences, there's a wide range of possibilities to explore with monster body parts.",
		L"Enhance your character's resistance capabilities with a variety of resistance potions, including fire, magic, poison, and lightning resistance. Stock up on these valuable consumables to bolster your defenses against elemental threats.",
		L"Dive into the Hardcore Ironman game mode, where survival is your top priority and every decision could mean life or death. With gold disabled and town portals replaced by waypoints, strategic gameplay and resource management are essential for success.",
		L"Experience the unique challenges of Hardcore Ironman, where underused skills become valuable and vitality is crucial for survival. Experiment with different weapons and strategies to overcome the dangers of this unforgiving game mode.",
		L"Prepare for the ultimate test of skill and strategy as you venture into Hardcore Ironman mode, where the stakes are high and the risks are greater than ever before. With gold rendered useless and town portals disabled, only the bravest adventurers will survive.",
		L"Master the art of survival in Hardcore Ironman mode, where every decision could mean the difference between life and death. With gold eliminated from the game and town portals disabled, strategic planning and careful resource management are essential for success.",
		L"Immerse yourself in the Hardcore Ironman experience, where the thrill of danger and the rush of victory await at every turn. With gold removed from the equation and town portals disabled, only the strongest and most resourceful adventurers will prevail.",
		L"Embark on a journey into the heart of darkness with Hardcore Ironman mode, where the challenges are greater, the risks are higher, and the rewards are more satisfying than ever before. Will you have what it takes to survive in this unforgiving world?",
		L"Test your skills and resilience in Hardcore Ironman mode, where every decision carries weight and every encounter could be your last. With gold no longer a factor and town portals disabled, only the most cunning and resourceful players will emerge victorious.",
		L"Challenge yourself to new heights of difficulty with Hardcore Ironman mode, where the stakes are higher, the dangers are greater, and the rewards are more satisfying than ever before. Can you overcome the ultimate test of skill and strategy?",
		L"Prepare for the ultimate test of survival in Hardcore Ironman mode, where every step could be your last and every decision could mean life or death. With gold out of the picture and town portals disabled, only the bravest adventurers will dare to venture forth.",
		L"Experience the adrenaline-fueled excitement of Hardcore Ironman mode, where danger lurks around every corner and death is always one misstep away. With gold rendered useless and town portals disabled, only the strongest and most resourceful heroes will prevail.",
		L"Dive into the heart of darkness with Hardcore Ironman mode, where the challenges are greater, the risks are higher, and the rewards are more satisfying than ever before. Will you have what it takes to conquer the perils that await?",
		L"Test your mettle in Hardcore Ironman mode, where survival is the ultimate goal and every decision could mean life or death. With gold eliminated from the game and town portals disabled, only the most skilled and determined adventurers will emerge victorious.",
		L"Prepare yourself for the ultimate challenge with Hardcore Ironman mode, where danger lurks around every corner and death is always a possibility. With gold removed from the equation and town portals disabled, only the bravest souls will dare to face the darkness.",
		L"Embark on an epic journey into the unknown with Hardcore Ironman mode, where the challenges are greater, the dangers are deadlier, and the rewards are more satisfying than ever before. Will you have what it takes to survive in this unforgiving world?",
		L"Test your limits in Hardcore Ironman mode, where every decision could mean life or death and every encounter is a battle for survival. With gold eliminated from the game and town portals disabled, only the strongest and most resourceful adventurers will prevail.",
		L"Experience the thrill of Hardcore Ironman mode, where danger lurks around every corner and death is always a possibility. With gold out of the picture and town portals disabled, only the bravest heroes will dare to venture forth into the unknown.",
		L"Dive into the heart of darkness with Hardcore Ironman mode, where the challenges are greater, the risks are higher, and the rewards are more satisfying than ever before. Will you have what it takes to overcome the perils that await?",
		L"Test your skills and resilience in Hardcore Ironman mode, where survival is the ultimate goal and every decision could mean life or death. With gold removed from the equation and town portals disabled, only the bravest adventurers will dare to venture forth.",
		L"Prepare for the ultimate test of survival in Hardcore Ironman mode, where danger lurks around every corner and death is always one misstep away. With gold rendered useless and town portals disabled, only the strongest and most resourceful heroes will prevail.",
		L"Experience the adrenaline-fueled excitement of Hardcore Ironman mode, where danger lurks around every corner and death is always a possibility. With gold eliminated from the game and town portals disabled, only the bravest souls will dare to face the darkness.",
		L"Dive into the heart of darkness with Hardcore Ironman mode, where the challenges are greater, the risks are higher, and the rewards are more satisfying than ever before. Will you have what it takes to survive in this unforgiving world?",
		L"Test your limits in Hardcore Ironman mode, where every decision could mean life or death and every encounter is a battle for survival. With gold out of the picture and town portals disabled, only the strongest and most resourceful adventurers will prevail.",

		L"Upgrade your Runes by combining any 3 Runes up to Lem to create the next Rune type. Likewise, merge any 2 Runes from Pul up to advance to the next level of Rune power.",
		L"Transform your Magic Charms by combining 3 of the same type into a new Magic Charm of the same variety. Whether they're Small, Large, or Grand, gather 3 Magic Charms to reroll them into a fresh version at 100% of your character's level.",
		L"Enhance your Jewels by gathering 3 of the same type and converting them into a new Jewel of the same category. Whether they're Magic or Rare, merge 3 Jewels to reroll them into a more potent version, matching your character's level at 100%.",
		L"Craft new Rings by combining sets of 3 Rings. Combine 3 Magic Rings to reroll them into a new Magic Ring at 75% of your character's level, or gather 3 Rare Rings to reroll them at full power.",
		L"Create new Amulets by collecting sets of 3 Amulets. Combine 3 Magic Amulets to reroll them into a fresh Magic Amulet at 75% of your character's level, or gather 3 Rare Amulets to reroll them into new Rare Amulets at full strength.",
		L"Unleash the power of Unique Arrows & Bolts by combining them with specific Runes and Gems. Mix a Quiver of Arrows or Bolts with the right combination of Runes and Gems to create unique ammunition, or replenish your Arrow Stack by combining any Unique Arrows or Bolts with a Health Potion.",
		L"Prepare your Armor, Shields, and Weapons for powerful Runewords by socketing them appropriately. Use specific Runes to add sockets to your equipment, allowing for the insertion of powerful Runewords to enhance their capabilities.",
		L"Add sockets to your Armor, Shields, and Weapons to prepare them for powerful upgrades. Combine specific Runes with various types of equipment to add sockets, enabling you to further customize and enhance their effectiveness.",
		L"Enhance your Weapons with the power of Chipped Gems, upgrading their damage and attributes. Combine any Weapon with Chipped Gems to add elemental damage, increased attack rating, or additional durability, depending on the gem used and its level.",
		L"Elevate your Weapons with Flawed Gems, infusing them with greater power and versatility. Combine any Weapon with Flawed Gems to significantly increase their elemental damage, attack rating, or durability, based on the gem type and its level.",
		L"Augment your Weapons with Regular Gems, imbuing them with even greater potency and effectiveness. Combine any Weapon with Regular Gems to substantially boost their elemental damage, attack rating, or durability, depending on the gem used and its level.",
		L"Empower your Weapons with Flawless Gems, unlocking their full potential and making them formidable tools of destruction. Combine any Weapon with Flawless Gems to dramatically increase their elemental damage, attack rating, or durability, depending on the gem type and its level.",
		L"Enrich your Weapons with the supreme power of Perfect Gems, granting them unparalleled strength and capability. Combine any Weapon with Perfect Gems to unleash devastating elemental damage, vastly improve attack rating, or significantly enhance durability, depending on the gem used and its level.",
		L"Fortify your Armor with the durability of Perfect Diamonds, ensuring they withstand the toughest battles. Combine any Armor with Perfect Diamonds to add durability, granting increased resistance to wear and tear.",
		L"Reinforce your Armor with the defensive prowess of Perfect Diamonds, bolstering their resilience against enemy attacks. Combine any Armor with 3 Perfect Diamonds to enhance defense, providing greater protection in combat.",


		L"Boost the effectiveness of all Armor types by combining them with various Runes and Magic Jewels. Enhance your Armor's attributes such as light radius, resistance, damage reduction, faster hit recovery, and more, depending on the combination used and the level of the runes.",
		L"Strengthen any Body Armor (Torso) by infusing it with the power of Runes and Magic Jewels. Improve attributes like stamina drain, mana per kill, defense, mana regeneration, damage reduction, resistances, and more, based on the combination of runes and jewels used.",
		L"Empower Belts, Boots, Gloves, and Helms with the magical properties of Runes and Magic Jewels. Enhance attributes such as stamina drain, mana per kill, defense, mana regeneration, damage reduction, resistances, and more, depending on the combination of runes and jewels used.",

	
		L"Improve the defensive capabilities of any Torso Armor by combining it with various Runes and Magic Jewels. Enhance attributes such as stamina drain, mana per kill, defense, mana regeneration, damage reduction, resistances, and magic find, depending on the combination used.",
		L"Strengthen the properties of Belts, Boots, Gloves, and Helms by infusing them with the magical essence of Runes and Magic Jewels. Enhance attributes like stamina drain, mana per kill, defense, mana regeneration, damage reduction, resistances, and magic find, based on the combination of runes and jewels employed.",
		L"Empower Shields with the mystical energy of Runes and Magic Jewels to bolster their defensive capabilities. Enhance attributes such as light radius, block chance, mana per kill, defense, mana regeneration, damage reduction, faster block rate, resistances, and magic find, depending on the combination of runes and jewels utilized.",


		
		L"Use a variety of weapons to exploit enemy vulnerabilities and resistances",
		L"Consume spirits like potions to increase Spirits Quaffed stat in character stat sheet page",
		L"Cube Souls with Energy Sphere to capture Soul Energy and use it to create powerful items. Recipes will come later",
		L"Collect Demon souls from demons and regular souls from monsters; Demon souls morph you into the demon whose soul you have",
		L"Spirits can be consumed like potions or put on as rings to add to Souls Consumed count",
		L"Cube underused magic, rare, set, unique items with Energy Sphere to collect their magic energy for creating new items",
		L"Cube white items with Energy Sphere to break down into simple item parts for creating base item types with smithing hammers",
		L"Use Rare Shard, Set Stone, or Unique Particle with smithing hammers and Energy Sphere to create rare, set, unique items",
		L"Acquire smithing hammers to create base item types, each requiring X number of collected item parts",
		L"Capture Talisman of Corruption and cube to corrupt items for new magical properties; a gamble with potential rewards",
		L"Use Experience Book for extra experience, Infinite Mana Elixir for massive mana regeneration, and Regeneration Elixir for life regeneration",
		L"Use Elixirs to permanently boost stats like Strength, Dexterity, Health, Stamina, Mana, and resistances",
		L"Equip Sling Stone for increased throwing potion damage, various elemental stones for resistance boosts, and Mastery Stones for skill damage boosts",
		L"Use Portable Shrines for temporary buffs like increased defense, damage, experience gained, mana regeneration, and skill levels",
		L"In Ironman, gold is nonexistent, town portals are disabled; rely on items, waypoints, and strategic gameplay to progress",
		L"Inventory management is critical; use items conservatively and intelligently switch gear based on monster types and situations",
		L"Hybrid character builds and creative weapon choices are encouraged in Ironman; experiment and adapt strategies accordingly",
		L"Protect hirelings actively as they are essential allies; they can be hired for 0 gold but lose items if they die",
		L"Coordinate with teammates in MultiPlayer; teamwork, resource sharing, and strategy are key to success in Ironman",
		L"In Hardcore Ironman, caution and careful planning are crucial; falling back, potion management, and adaptability are essential for survival",
		L"Utilize waypoints for inter-level travel in Ironman; waypoints become crucial for navigating the game world",
		L"Always have backup gear in your backpack in Ironman; switch out gear intelligently based on monster types and challenges",
		L"Experiment with different weapons and gear in Ironman; adapt your strategies to overcome various monster types and situations",
		L"Keep a close watch on your hirelings' health in Ironman; losing a hireling means losing their equipped items as well",
		L"Plan and communicate effectively in MultiPlayer Ironman games; teamwork and coordination are key to overcoming challenges",
		L"Be conservative with resources in Hardcore Ironman; strategic planning and careful execution are vital for survival",
		L"Craft rare, set, unique items using collected item parts and smithing hammers in Ironman; choose item types wisely for your build",
		L"Capture and corrupt items using Talisman of Corruption for new magical properties in Ironman; take calculated risks for potential rewards",
		L"Use Portable Shrines strategically in Ironman for temporary buffs; timing and placement of shrines can turn the tide of battle",
		L"Keep track of Souls Consumed and Spirits Quaffed stats in Ironman; they reflect your progress and resource utilization in the game",
		L"Enhance your character with Elixirs and Stones for permanent stat boosts and bonuses in Ironman; plan your upgrades wisely",
		L"Master the art of retreating and regrouping in Hardcore Ironman; strategic fallbacks can save your character's life in tough situations",
		L"Stay vigilant and adapt your strategies in MultiPlayer Ironman games; synergy and cooperation with teammates are essential for success",
		L"Experiment with different skill synergies and builds in Ironman; explore the full potential of your character's abilities",
		L"Craft and equip powerful unique items using collected Magic Essence Points and recipes in Ironman; customize your gear for optimal performance",
		L"Explore new areas and challenges in Ironman; discover hidden secrets and encounters by venturing off the beaten path",
		L"Combine different magic, rare, set, unique items with the Energy Sphere to collect their magic energy in Ironman",
		L"Cube white items with the Energy Sphere to break them down into simple item parts for crafting in Ironman",
		L"Use smithing hammers with the Energy Sphere to create base item types for crafting in Ironman",
		L"Combine Rare Shard, Set Stone, or Unique Particle with base item types and Magic Essence Points to create rare, set, unique items in Ironman",
		L"Cube Souls with the Energy Sphere to capture their energy and use it for creating more powerful items in Ironman",
		L"Capture Talisman of Corruption and cube it to corrupt items for new magical properties in Ironman; a gamble with potential rewards",
		

};


void OnLoad() {
	srand(time(NULL));
}


#include <iostream>
#include <sstream>
#include <algorithm>
#include <vector>

using namespace std;

// Function to break the tip into words
vector<string> split(const string& s, char delim) {
	stringstream ss(s);
	string item;
	vector<string> tokens;
	while (getline(ss, item, delim)) {
		tokens.push_back(item);
	}
	return tokens;
}

// Function to create sentences from words
string makeSentence(vector<string> words, int start, int end) {
	stringstream ss;
	for (int i = start; i <= end; ++i) {
		ss << words[i] << " ";
	}
	return ss.str();
}

// Function to convert string to wide string
wstring stringToWstring(const string& s) {
	wstring ws;
	for (char c : s) {
		ws += (wchar_t)c;
	}
	return ws;
}

	// Your original code here

	// Modified onDraw function
	//void onDraw() {
	//	if (GetTickCount64() >= nEndTime) {
	//		nEndTime = GetTickCount64() + DURATION;
	//		nTip = rand() % diablo2Tips.size();
	//	}

	//	// Convert wstring to string for manipulation
	//	string strTip = string(diablo2Tips[nTip].begin(), diablo2Tips[nTip].end());
	//	vector<string> words = split(strTip, ' ');

	//	// Calculate positions for multiple lines
	//	int yPos = 65;
	//	for (int i = 0; i < words.size(); i += 5) {
	//		// Create a sentence from words and convert it back to wide string
	//		string sentence = makeSentence(words, i, min(i + 4, (int)words.size() - 1));
	//		wstring wSentence = stringToWstring(sentence);
	//		D2PrintString(const_cast<LPWSTR>(wSentence.c_str()), 152, yPos, D2Color::WHITE, 0);
	//		yPos += 14; // Move to the next line
	//	}
	//}

// Helper function to justify a line of text
void justifyLine(const vector<string>& words, int start, int end, int maxLineLength, int yPos) {
	// Handle the case when there is only one word in the line
	if (start == end) {
		wstring word = stringToWstring(words[start]);
		D2PrintString(const_cast<LPWSTR>(word.c_str()), 130, yPos, D2Color::WHITE, 0);
		return;
	}

	// Calculate the total length of the line (excluding spaces)
	int lineLength = 0;
	for (int i = start; i <= end; i++) {
		lineLength += D2Win_GetTextWidth(const_cast<LPWSTR>(stringToWstring(words[i]).c_str())); // Get the actual width of the word

	}

	// Calculate the number of spaces to distribute
	int numSpaces = end - start;
	int extraSpaces = maxLineLength - lineLength;

	// Distribute the extra spaces evenly
	int spaceWidth = 1;
	int extraSpacePerGap = extraSpaces / numSpaces;
	int remainingSpaces = extraSpaces % numSpaces;

	// Build the justified line
	wstring wLine;
	int xPos = 152;
	for (int i = start; i <= end; i++) {
		wstring word = stringToWstring(words[i]);
		D2PrintString(const_cast<LPWSTR>(word.c_str()), xPos, yPos, D2Color::WHITE, 0);
		xPos += D2Win_GetTextWidth(const_cast<LPWSTR>(stringToWstring(words[i]).c_str())) + (spaceWidth + extraSpacePerGap);

		if (remainingSpaces > 0) {
			xPos += 1; // Add an extra pixel for the remaining spaces
			remainingSpaces--;
		}
	}
}
// Refactored onDraw function
void onDraw() {
	if (GetTickCount64() >= nEndTime) {
		nEndTime = GetTickCount64() + DURATION;
		nTip = rand() % diablo2Tips.size();
	}

	// Convert wstring to string for manipulation
	string strTip = string(diablo2Tips[nTip].begin(), diablo2Tips[nTip].end());
	vector<string> words = split(strTip, ' ');

	// Calculate positions for multiple lines
	int yPos = 65;
	int lineStart = 0;
	int lineLength = 0;
	int maxLineLength = 580 - 152; // Maximum line length in pixels

	for (int i = 0; i < words.size(); i++) {
		// Get the length of the current word
		// int wordLength = words[i].length() * 8; // Assuming a fixed-width font with 8 pixels per character
		int wordLength = D2Win_GetTextWidth(const_cast<LPWSTR>(stringToWstring(words[i]).c_str())); // Get the actual width of the word

		// If adding the current word would exceed the maximum line length, print the current line
		if (lineLength + wordLength > maxLineLength) {
			// Justify the current line
			justifyLine(words, lineStart, i - 1, maxLineLength, yPos);

			// Move to the next line
			yPos += 14;
			lineStart = i;
			lineLength = 0;
		}

		// Add the current word to the line
		lineLength += wordLength + 8; // Add space length (8 pixels)
	}

	// Print the last line if it exists
	if (lineStart < words.size()) {
		//justifyLine(words, lineStart, words.size() - 1, maxLineLength, yPos);
		wstring wLine = stringToWstring(makeSentence(words, lineStart, words.size() - 1));
		D2PrintString(const_cast<LPWSTR>(wLine.c_str()), 152, yPos, D2Color::WHITE, 0);
	}
}

//// Refactored onDraw function
//void onDraw() {
//	if (GetTickCount64() >= nEndTime) {
//		nEndTime = GetTickCount64() + DURATION;
//		nTip = rand() % diablo2Tips.size();
//	}
//
//	// Convert wstring to string for manipulation
//	string strTip = string(diablo2Tips[nTip].begin(), diablo2Tips[nTip].end());
//	vector<string> words = split(strTip, ' ');
//
//	// Calculate positions for multiple lines
//	int yPos = 65;
//	int lineStart = 0;
//	int lineLength = 0;
//	int maxLineLength = 590 - 158; // Maximum line length in pixels
//
//	for (int i = 0; i < words.size(); i++) {
//		// Get the length of the current word
//		int wordLength = words[i].length() * 8; // Assuming a fixed-width font with 8 pixels per character
//
//		// If adding the current word would exceed the maximum line length, print the current line
//		if (lineLength + wordLength > maxLineLength) {
//			// Print the current line
//			wstring wLine = stringToWstring(makeSentence(words, lineStart, i - 1));
//			D2PrintString(const_cast<LPWSTR>(wLine.c_str()), 130, yPos, D2Color::WHITE, 0);
//
//			// Move to the next line
//			yPos += 14;
//			lineStart = i;
//			lineLength = 0;
//		}
//
//		// Add the current word to the line
//		lineLength += wordLength + 8; // Add space length (8 pixels)
//	}
//
//	// Print the last line
//	if (lineStart < words.size()) {
//		wstring wLine = stringToWstring(makeSentence(words, lineStart, words.size() - 1));
//		D2PrintString(const_cast<LPWSTR>(wLine.c_str()), 130, yPos, D2Color::WHITE, 0); //diablo2::d2_gfx::draw_filled_rect(130, 48, 640, 155, 5, 50);
//	}
//}



void FASTCALL printPageNumber(LPWSTR maxGoldText, DWORD x, DWORD y, DWORD color, DWORD bfalse)
{
	if (onRealm || !D2isLODGame() )
	{
		D2PrintString(maxGoldText,x,y,color,bfalse);
		return;
	}

	DWORD mx = D2GetMouseX();
	DWORD my = D2GetMouseY();
	Unit* ptChar = D2GetClientPlayer();
	WCHAR popupText[0x400];

	if (!PCPY->currentStash)
		D2PrintString(getLocalString(STR_NO_SELECTED_PAGE), x, y, WHITE, bfalse);
	else
	{
		bool isShared = PCPY->currentStash->isShared;
		bool isIndex = PCPY->currentStash->isIndex;
		bool isMainIndex = PCPY->currentStash->isMainIndex;
		DWORD currentId = PCPY->currentStash->id + 1;

		WCHAR text[21];
		getCurrentStashName(text, 21, ptChar);
		// Replace character # by number page.
		int j = 0;
		for (int i = 0; text[i]; i++)
		{
			if (text[i] == L'#')
			{
				DWORD val = currentId;
				int nbDigits = 0;
				do
				{
					nbDigits++;
					val /= 10;
				} while (val);
				j += nbDigits;

				val = currentId;
				nbDigits = 0;
				do
				{
					nbDigits++;
					popupText[j - nbDigits] = (WCHAR)(val % 10 + 48);
					val /= 10;
				} while (val);
			}
			else
				popupText[j++] = text[i];
		}
		popupText[j] = NULL;

		// Check text length vs field name length
		int pixelLen = D2GetPixelLen(popupText);
		int len = wcslen(popupText);
		while (len > 0 && pixelLen > posWStashNameField - 5)
		{
			len--;
			popupText[len] = NULL;
			pixelLen = D2GetPixelLen(popupText);
		}

		DWORD color = isShared ? (isMainIndex ? SharedMainIndexPageColor : isIndex ? SharedIndexPageColor : SharedNormalPageColor) : (isMainIndex ? PersonalMainIndexPageColor : isIndex ? PersonalIndexPageColor : PersonalNormalPageColor);

		// By HashCasper
		D2PrintString(popupText, 152, 605, color, bfalse);

		// Mapping from int to ui_font_t
		//std::map<int, diablo2::ui_font_t> fontMap = {
		//	{0, diablo2::ui_font_t::UI_FONT_8},
		//	{1, diablo2::ui_font_t::UI_FONT_16},
		//	{2, diablo2::ui_font_t::UI_FONT_30},
		//	{3, diablo2::ui_font_t::UI_FONT_42},
		//	{4, diablo2::ui_font_t::UI_FONT_FORMAL10},
		//	{5, diablo2::ui_font_t::UI_FONT_FORMAL12},
		//	{6, diablo2::ui_font_t::UI_FONT_6},
		//	{7, diablo2::ui_font_t::UI_FONT_24},
		//	{8, diablo2::ui_font_t::UI_FONT_FORMAL11},
		//	{9, diablo2::ui_font_t::UI_FONT_EXOCET10},
		//	{10, diablo2::ui_font_t::UI_FONT_RIDICULOUS},
		//	{11, diablo2::ui_font_t::UI_FONT_EXOCET8},
		//	{12, diablo2::ui_font_t::UI_FONT_REALLYTHELASTSUCKER},
		//	{13, diablo2::ui_font_t::UI_FONT_INGAMECHAT}
		//};


		D2SetFont(2);
		WCHAR HashString[] = L"Ironman Mod by Hash";
		D2PrintString(HashString, 150, 35, color, bfalse);

		// Print Random Tips		
		D2SetFont(0);
		onDraw();

		// Reset font after printing
		D2SetFont(8);

	}
}

static Stash* curStash=NULL;
static DWORD currentSawStash=0;
Unit* STDCALL getNextItemForSet(Unit* ptItem)
{
	Unit* item = ptItem?D2UnitGetNextItem(ptItem):NULL;
	if (item) return item;

	if (!curStash)
	{
		Unit* ptChar = D2GetClientPlayer();
		switch (currentSawStash)
		{
		case 0: curStash = PCPY->selfStash;
				currentSawStash = displaySharedSetItemNameInGreen ? 1 : 2;
				break;
		case 1: curStash = PCPY->sharedStash;
				currentSawStash = 2;
				break;
		default:return NULL;
		}
	} else {
		curStash = curStash->nextStash;
	}
	if (curStash)
	{
		item = curStash->ptListItem;
		if (item) return item;
	}
	return getNextItemForSet(item);
}

Unit* STDCALL initGetNextItemForSet(Inventory* ptInventory)
{
	Unit* ptChar = D2GetClientPlayer();
	if (ptChar->nUnitType != UNIT_PLAYER) return NULL;
	if (!PCPY) return NULL;

	curStash = NULL;
	currentSawStash = 0;
	Unit* item = D2InventoryGetFirstItem(ptInventory);
	if (item) return item;
	return getNextItemForSet(item);
}

FCT_ASM( caller_manageBtnDown_114 )
	PUSH EBX
	CALL manageBtnDown
	TEST EAX,EAX
	JE IS_NOT_ON_BUTTON
	POP EDX
	MOV EDX, DWORD PTR DS:[EDX+0xA]
	MOV DWORD PTR DS:[EDX],1
	POP EDI
	POP ESI
	POP EBX
	MOV ESP,EBP
	POP EBP
	RETN 4
IS_NOT_ON_BUTTON:
	JMP D2ClickOnStashButton
}}

FCT_ASM( caller_manageBtnDown_111 )
	PUSH EBP
	CALL manageBtnDown
	TEST EAX,EAX
	JE IS_NOT_ON_BUTTON
	POP EDX
	MOV EDX, DWORD PTR DS:[EDX+0x10]
	MOV DWORD PTR DS:[EDX],1
	POP EDI
	POP ESI
	POP EBP
	POP EBX
	RETN 4
IS_NOT_ON_BUTTON:
	JMP D2ClickOnStashButton
}}

FCT_ASM( caller_manageBtnDown )
	PUSH EDI
	CALL manageBtnDown
	TEST EAX,EAX
	JE IS_NOT_ON_BUTTON
	POP EDX
	MOV EDX, DWORD PTR DS:[EDX+0xF3]
	MOV DWORD PTR DS:[EDX],1
	POP EDI
	POP ESI
	POP EBP
	POP EBX
	RETN 4
IS_NOT_ON_BUTTON:
	JMP D2isLODGame
}}

FCT_ASM( caller_manageBtnUp_114 )
	PUSH EBX
	CALL manageBtnUp
	MOV isDownBtn.all,0
	TEST EAX,EAX
	JE IS_NOT_ON_BUTTON
	POP EDX
	MOV EDX, DWORD PTR DS:[EDX+0x33]
	MOV DWORD PTR DS:[EDX],0
	SUB EDX,8
	MOV DWORD PTR DS:[EDX],0
	ADD EDX,4
	MOV DWORD PTR DS:[EDX],0
	ADD EDX,0x64
	MOV DWORD PTR DS:[EDX],0
	POP EDI
	POP ESI
	POP EBX
	MOV ESP,EBP
	POP EBP
	RETN 4
IS_NOT_ON_BUTTON:
	JMP D2ClickOnStashButton
}}

FCT_ASM( caller_manageBtnUp_111 )
	PUSH EBX
	CALL manageBtnUp
	MOV isDownBtn.all,0
	TEST EAX,EAX
	JE IS_NOT_ON_BUTTON
	POP EDX
	MOV EDX, DWORD PTR DS:[EDX+0x1A]
	MOV DWORD PTR DS:[EDX],0
	SUB EDX,8
	MOV DWORD PTR DS:[EDX],0
	ADD EDX,4
	MOV DWORD PTR DS:[EDX],0
	ADD EDX,0x68
	MOV DWORD PTR DS:[EDX],0
	POP EDI
	POP ESI
	POP EBP
	POP EBX
	POP ECX
	RETN 4
IS_NOT_ON_BUTTON:
	JMP D2ClickOnStashButton
}}

FCT_ASM( caller_manageBtnUp )
	PUSH EBP
	CALL manageBtnUp
	MOV isDownBtn.all,0
	TEST EAX,EAX
	JE IS_NOT_ON_BUTTON
	POP EDX
	MOV EDX, DWORD PTR DS:[EDX+0xEA]
	MOV DWORD PTR DS:[EDX],0
	SUB EDX,8
	MOV DWORD PTR DS:[EDX],0
	ADD EDX,4
	MOV DWORD PTR DS:[EDX],0
	ADD EDX,0x68
	MOV DWORD PTR DS:[EDX],0
	POP EDI
	POP ESI
	POP EBP
	POP EBX
	RETN 4
IS_NOT_ON_BUTTON:
	JMP D2isLODGame
}}

FCT_ASM ( initBtnsStates_114 )
	MOV isDownBtn.all,0
	POP ECX
	MOV ESP,EBP
	POP EBP
	RETN
}}

FCT_ASM ( initBtnsStates )
	MOV isDownBtn.all,0
	ADD ESP,0x104
	RETN
}}


void Install_InterfaceStash()
{
	static int isInstalled = false;
	if (isInstalled) return;

	Install_UpdateServer();
	Install_PlugYImagesFiles();

	log_msg("Patch D2Client for stash interface. (InterfaceStash)\n");

	// Print button images
	mem_seek R8(D2Client, 39060, 39060, 3F399, B1006, 7DF86, B3656, 99A56, 9DE26, 8F308);
	MEMC_REF4( D2LoadBuySelBtn, printBtns);
	//6FADF398  |. E8 734D0400    CALL D2Client.6FB24110
	//6FB61005  |. E8 A6D3FEFF    CALL D2Client.6FB4E3B0
	//6FB2DF85  |. E8 3642FEFF    CALL D2Client.6FB121C0
	//6FB63655  |. E8 9682FDFF    CALL D2Client.6FB3B8F0
	//6FB49A55  |. E8 96500200    CALL D2Client.6FB6EAF0
	//6FB4DE25  |. E8 76ACF7FF    CALL D2Client.6FAC8AA0
	//0048F307  |. E8 F452FCFF    CALL Game.00454600

	// print page number
	mem_seek R8(D2Client, 3903C, 3903C, 3F375, B0FE3, 7DF63, B3633, 99A33, 9DE03, 8F2E5);

	MEMJ_REF4( D2PrintString, printPageNumber);
	


	//6FADF374  |. E8 3FCC0800    CALL <JMP.&D2Win.#10117>
	//6FB60FE2  |. E8 99C2F5FF    CALL <JMP.&D2Win.#10020>
	//6FB2DF62  |. E8 19F3F8FF    CALL <JMP.&D2Win.#10064>
	//6FB63632  |. E8 299DF5FF    CALL <JMP.&D2Win.#10001>
	//6FB49A32  |. E8 4739F7FF    CALL <JMP.&D2Win.#10150>
	//6FB4DE02  |. E8 4739F7FF    CALL <JMP.&D2Win.#10076>
	//0048F2E4  |. E8 37300700    CALL Game.00502320                       ; \Game.00502320

	// Manage mouse down (Play sound)
	mem_seek R8(D2Client, 45091, 45091, 4BBA1, B4666, 7FDD6, B54A6, 9B8A6, 9FC76, 925B8);
	MEMC_REF4( version_D2Client >= V111 ? (DWORD)D2ClickOnStashButton : (DWORD)D2isLODGame, version_D2Client >= V114a ? caller_manageBtnDown_114 : version_D2Client >= V111 ? caller_manageBtnDown_111 : caller_manageBtnDown);
	//6FAEBBA0   > E8 DB04FCFF    CALL D2Client.6FAAC080
	//6FB64665   . E8 B61EFFFF    CALL D2Client.6FB56520
	//6FB2FDD5   . E8 E612FFFF    CALL D2Client.6FB210C0
	//6FB654A5   . E8 9611FFFF    CALL D2Client.6FB56640
	//6FB4B8A5   . E8 5614FFFF    CALL D2Client.6FB3CD00
	//6FB4FC75   . E8 960FFFFF    CALL D2Client.6FB40C10
	//004925B7  |. E8 C473FFFF    CALL Game.00489980

	// Manage mouse up
	mem_seek R8(D2Client, 455F9, 455F9, 4C0F9, B57B9, 7FC09, B52D9, 9B6D9, 9FAA9, 89B63);
	MEMC_REF4( version_D2Client >= V111 ? (DWORD)D2ClickOnStashButton : (DWORD)D2isLODGame, version_D2Client >= V114a ? caller_manageBtnUp_114 : version_D2Client >= V111 ? caller_manageBtnUp_111 : caller_manageBtnUp);
	//6FAEC0F8   > E8 83FFFBFF    CALL D2Client.6FAAC080
	//6FB657B8   > E8 630DFFFF    CALL D2Client.6FB56520
	//6FB2FC08   > E8 B314FFFF    CALL D2Client.6FB210C0
	//6FB652D8   > E8 6313FFFF    CALL D2Client.6FB56640
	//6FB4B6D8   > E8 2316FFFF    CALL D2Client.6FB3CD00
	//6FB4FAA8   > E8 6311FFFF    CALL D2Client.6FB40C10
	//00489B62  |> E8 19FEFFFF    CALL Game.00489980

	// init state of button on open stash page
	mem_seek R8(D2Client, 45B3A, 45B3A, 4C63A, A645A, 749DA, A9D9A, 8CC3A, 9441A, 89ED5);
	if (version_D2Client >= V114d)
	{
		memt_byte( 0x8B, 0xE9 );	// CALL initBtnsStates
		MEMT_REF4( 0xCCC35DE5, initBtnsStates_114);
	} else {
		memt_byte( 0x81, 0xE9 );	// CALL initBtnsStates
		MEMT_REF4( 0x000104C4, initBtnsStates);
		memt_byte( 0x00, 0x90 );
	}
	//6FAE5B3A  |> 81C4 04010000  ADD ESP,104
	//6FAE5B3A  |> 81C4 04010000  ADD ESP,104
	//6FAEC63A  |> 81C4 04010000  ADD ESP,104
	//6FB5645A  |> 81C4 04010000  ADD ESP,104
	//6FB249DA  |> 81C4 04010000  ADD ESP,104
	//6FB59D9A  |> 81C4 04010000  ADD ESP,104
	//6FB3CC3A  |> 81C4 04010000  ADD ESP,104
	//6FB4441A  |> 81C4 04010000  ADD ESP,104
	//00489ED5  |> 8BE5           MOV ESP,EBP
	//00489ED7  |. 5D             POP EBP
	//00489ED8  \. C3             RETN
	//00489ED9     CC             INT3

	// init the search of print in green the item set name we have in stash
	mem_seek R8(D2Client, 3F098, 3F098, 45997, A71F4, 71F64, A7314, 8D434, 91A24, 86774);
	MEMJ_REF4( D2InventoryGetFirstItem, initGetNextItemForSet);
	//6FAE5996  |. E8 D5500800    CALL <JMP.&D2Common.#10277>
	//6FB571F3  |. E8 D64EF6FF    CALL <JMP.&D2Common.#10402>
	//6FB21F63  |. E8 96A1F9FF    CALL <JMP.&D2Common.#10535>
	//6FB57313  |. E8 8250F6FF    CALL <JMP.&D2Common.#11151>
	//6FB3D433  |. E8 B8F0F7FF    CALL <JMP.&D2Common.#10460>
	//6FB41A23  |. E8 96A7F7FF    CALL <JMP.&D2Common.#11040>
	//00486773  |. E8 484B1B00    CALL Game.0063B2C0                       ; \Game.0063B2C0

	// Get next item for print in green the item set name we have in stash
	mem_seek R8(D2Client, 3F0FA, 3F0FA, 45A1C, A728B, 71FFB, A73AB, 8D4CB, 91ABB, 86807);
	MEMJ_REF4( D2UnitGetNextItem, getNextItemForSet);
	//6FAE5A1B   E8 4A500800      CALL <JMP.&D2Common.#10304>
	//6FB5728A  |. E8 0B4FF6FF    |CALL <JMP.&D2Common.#10934>
	//6FB21FFA  |. E8 A1A1F9FF    |CALL <JMP.&D2Common.#11140>
	//6FB573AA  |. E8 7550F6FF    |CALL <JMP.&D2Common.#10770>
	//6FB3D4CA  |. E8 99F0F7FF    |CALL <JMP.&D2Common.#10464>
	//6FB41ABA  |. E8 A3A8F7FF    |CALL <JMP.&D2Common.#10879>
	//00486806  |. E8 95771B00    |CALL Game.0063DFA0                      ; \Game.0063DFA0

	log_msg("\n");

	isInstalled = true;
}

/*================================= END OF FILE =================================*/